/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.explorer.page.QueryList"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.explorer.page.ExplorerClient"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.MoveQuery"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.MetaNav"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.matrix.CreateMatrixWizard"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util"); //$NON-NLS-1$

dojo.require("dojo.date"); //$NON-NLS-1$
dojo.require("dojo.date.stamp"); //$NON-NLS-1$
dojo.require("dojo.date.locale"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
dojo.require("dijit.form.ToggleButton"); //$NON-NLS-1$
dojo.require("jazz.ui.FilterBox"); //$NON-NLS-1$
dojo.require("jazz.util.html"); //$NON-NLS-1$
dojo.require("jazz.ui.StyledTable"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$
dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.Toolbar"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryListMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var JazzUIWorkbench = net.jazz.ajax.ui.PlatformUI.getWorkbench();
var ActionPrefix = "#action=com.ibm.relm.explorer.web.showQueryList"; //$NON-NLS-1$
var FOLDERTYPE = "folder"; //$NON-NLS-1$
var QUERYTYPE = "query"; //$NON-NLS-1$
var INDENT = 20;
var INDENT2 = 40;

var ExplorerClient = com.ibm.relm.explorer.web.explorer.page.ExplorerClient;
var ServiceResponseHandler = com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler;
var FilterBox = jazz.ui.FilterBox;
var StyledTable = jazz.ui.StyledTable;
var PlatformUI = net.jazz.ajax.ui.PlatformUI;

var COLLAPSE_ICON = dojo.moduleUrl("com.ibm.relm.explorer.web", "explorer/images/collapse.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var EXPAND_ICON = dojo.moduleUrl("com.ibm.relm.explorer.web", "explorer/images/expand.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.relm.explorer.web.explorer.page.QueryList", //$NON-NLS-1$
		[dijit._Widget, dijit._Templated],
{
	queryPage: null,
	myQueriesTab: null,
	sharedQueriesTab: null,
	_childMap: {},
	_colexpState: {},
	_folders: {},
	_widgets: [],
	_callCount: 0,
	_previousSelectedQueryUri: null,
	_prevSelectedRow: null,
	_refreshRequired: false,
	
	runQueryAction: "#action=com.ibm.relm.explorer.web.showExplorer&queryUri=", //$NON-NLS-1$
	editFolderAction:"#action=com.ibm.relm.explorer.web.editQueryFolder", //$NON-NLS-1$
	createQueryAction: "#action=com.ibm.relm.explorer.web.showExplorer&mode=create", //$NON-NLS-1$

	// template
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/page/templates/QueryList.html"), //$NON-NLS-1$ //$NON-NLS-2$

	
	postMixInProperties: function() {
		this.inherited(arguments);
		this._messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.explorer.internal", "QueryListMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	postCreate: function(){
		this.inherited(arguments);
		var messages = this._messages;
		this.shared = (this.scope == "shared") ? true : false; //$NON-NLS-1$
		// set title
		this.myQueriesTab = new dijit.form.ToggleButton({label: this._messages.PrivateQueries});
		this.connect(this.myQueriesTab, "onClick", "onMyQueries"); //$NON-NLS-1$ //$NON-NLS-2$
		this.sharedQueriesTab = new dijit.form.ToggleButton({label: this._messages.SharedQueries});
		this.connect(this.sharedQueriesTab, "onClick", "onSharedQueries"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.place(this.myQueriesTab.domNode, this.titleArea);
		dojo.place(this.sharedQueriesTab.domNode, this.titleArea);

		this._filterBox = new FilterBox({onChange: dojo.hitch(this,this._doFilter)});
		this._filterArea.appendChild(this._filterBox.domNode);
		this._table = new StyledTable({columns: [{label: messages.Name, width: "30%", sortable: true}, //$NON-NLS-1$
		                                         {label: messages.CreatedBy, width: "14%", sortable: true}, //$NON-NLS-1$
		                                         {label: messages.LastUpdated, width: "14%", sortable: true}, //$NON-NLS-1$
		                                         {label: messages.Actions, width: "12%", className: "action-column", sortable: false}], //$NON-NLS-1$ //$NON-NLS-2$
		                                        trim: jazz.ui.StyledTable.TrimStyles.PRIMARY_HEADLESS, 
		                                        handleSort: dojo.hitch(this, this._handleSort),
		                                        sortBy: 0,
		                                        sortByAscending: true,
		                                        showHover: true});
		this._resultsArea.appendChild(this._table.domNode);
		this._populateHeader();
		// initialize permission
		this.initPermission();
	},

	/**
	*	This is the function that is used to handle the sorting of the styled table. 
	*/
	_handleSort: function() {
		this._emptyTable();
		this._sortChildren(this._rootFolder.children, null, 9, this._rootFolder.folderUUID, true);
	},

	/**
	 * Function to recursively sort folders
	 */
	_sortChildren: function(children, parentDiv, parentPadding, parentUUID, fShow) {
		parentDiv && this.showExpando(parentDiv, (children.folders.length || children.queries.length));
		var folders = children.folders;
		this._performSort(folders);
		dojo.forEach(folders, function(folder) {
			var folderDiv;
			var padding;
			if (parentDiv) {
				padding = parentPadding + INDENT;
				folderDiv = this._createFolderRow(folder, padding, fShow);
				this._insertAfter(folderDiv, this._getFolderInsertionPoint(parentDiv));
			}
			else {//In root folder 
				padding = 9;
				folderDiv = this._createFolderRow(folder, padding, true);
				this._table.tbody.appendChild(folderDiv);
			}
			this._sortChildren(folder.children, folderDiv, padding, folder.folderUUID,this._colexpState[folder.folderUUID]);
		}, this);
		//Sort queries
		this._sortAndPlaceQueries(children.queries, parentDiv, parentPadding, parentUUID, fShow);
	},

	_sortAndPlaceQueries: function(queries, parentDiv, padding, folderUUID, fShow) {
		var inFolder = !!parentDiv;

		this._performSort(queries);

		if (inFolder) {
			dojo.forEach(queries, function(query) {
				this._insertAfter(this._createQueryRow(query, padding + INDENT2, this._colexpState[folderUUID]), this._getQueryInsertionPoint(folderUUID));
			}, this);
		} else {//In root folder
			dojo.forEach(queries, function(query) {
				dojo.place(this._createQueryRow(query, padding + INDENT, true), this._table.tbody, "last"); //$NON-NLS-1$
			}, this);
		}
	},

	/**
	*	Calls the appropriate sorting function on this Array based on which columns off 
	*	the table needs to be sorted
	*
	*	There are three sorting functions (name, date and creator). Each is called with dojo.partial
	*	which sneeks in a parameter to tell the function which order to sort in (ascending/descending)
	*	@param {Array} foldersOrRows 
	*/
	_performSort: function(foldersOrRows) {
		var table = this._table;
		var sortBy = table.sortBy;
		var aToz = table.sortByAscending;

		switch (sortBy) {
			case 0:
				return foldersOrRows.sort(dojo.hitch(this, dojo.partial(this._sortByName, aToz)));
			case 1: 
				return foldersOrRows.sort(dojo.hitch(this, dojo.partial(this._sortByCreator, aToz)));
			case 2:
				return foldersOrRows.sort(dojo.hitch(this, dojo.partial(this._sortByDate, aToz)));
		}
	},

	_sortByName: function(asc, row1, row2) {
		var retVal;
		var name1 = row1.name.label;
		var name2 = row2.name.label;
		if (name1 < name2)
			retVal = -1;
		else if (name1 > name2)
			retVal = 1;
		else retVal = 0;

		if(asc)
			return retVal;
		else
			return retVal * -1;
	},

	_sortByDate: function(asc, row1, row2) {
		var date1 = dojo.date.stamp.fromISOString(row1.modified);
		var date2 = dojo.date.stamp.fromISOString(row2.modified);
		var retVal = date1 - date2;

		if(asc)
			return retVal;
		else
			return retVal * -1;
	},

	_sortByCreator: function(asc, row1, row2) {
		var name1 = this._getDisplayValue(row1.creator);
		var name2 = this._getDisplayValue(row2.creator);
		
		var retVal;
		if (name1 < name2)
			retVal = -1;
		else if (name1 > name2)
			retVal = 1;
		else retVal = 0;

		if(asc)
			return retVal;
		else
			return retVal * -1;
	},
	
	_populateHeader: function(){
		var messages = this._messages;
		var title = this.shared ? messages.SharedQueries : messages.PrivateQueries;
		this.metanav.setTitle(jazz.util.html.escape(title));

		var toolbar = new jazz.ui.SimpleToolbar({});
		this.metanav._toolbar = toolbar;
		this.metanav._toolbarDiv.appendChild(toolbar.domNode);
		toolbar.addButton(this, this._newQuery, {showLabel: true, imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web", "explorer/images/new_resource.gif"), label: messages.createQuery, requiresSelection:false, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._newFolder, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/new-folder-obj.gif"), label: this._messages.createFolder, requiresSelection:false, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._runNewQuery, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/refresh16.gif"), label: messages.refresh, requiresSelection:false}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._deleteItems, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/delete_hov.gif"), label: messages.deleteQueryMsg, requiresSelection:true, requireDelete:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._moveItems, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/movecopy.gif"), label: messages.moveQuery, requiresSelection:true, moveCopy:true}); //$NON-NLS-1$ //$NON-NLS-2$
		this._generateMatrixButton = toolbar.addButton(this, this._generateMatrix, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/matrix.gif"), label: messages.generateMatrix, requiresSelection:true, matrix:true}); //$NON-NLS-1$ //$NON-NLS-2$
		toolbar.addButton(this, this._exportQueries, {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","explorer/images/download_co.gif"), label: messages.exportQueries, requiresSelection:true, requireCreate:true}); //$NON-NLS-1$ //$NON-NLS-2$
		this.refreshButton = this.metanav._toolbar.getItem(2);

		if(this.shared == true) this.metanav.createContextSensitiveHelp("com.ibm.relm.explorer.web.page_SharedQueries001"); //$NON-NLS-1$
		else this.metanav.createContextSensitiveHelp("com.ibm.relm.explorer.web.page_MyQueries001"); //$NON-NLS-1$
		
		if(this.displayBreadcrumbs) {
			this.metanav.populateReportsBreadcrumbs();
		} else {
			this.metanav.handle.style.height = "30px"; //$NON-NLS-1$
			this.metanav.handle.style.minHeight = "30px"; //$NON-NLS-1$
		}
	},
	
	
	getTitleString: function(){
		if(this.myQueriesTab.checked){
			return this.myQueriesTab.label;
		} else {
			return this.sharedQueriesTab.label;
		}
	},
	
	onMyQueries: function(){
		window.location = ActionPrefix + "&scope=personal"; //$NON-NLS-1$
		JazzUIWorkbench.setTitle(this._messages.PrivateQueries);
	},

	onSharedQueries: function(){
		window.location = ActionPrefix + "&scope=shared"; //$NON-NLS-1$
		JazzUIWorkbench.setTitle(this._messages.SharedQueries);
	},
	
	initPermission: function(){

		var self = this;
		jazz.client.xhrGet({
			url: com.ibm.relm.explorer.web.ui.queryServiceUri + "?id=-1" + "&permission=", //$NON-NLS-1$ //$NON-NLS-2$
			headers: {"Accept":"application/json"}, //$NON-NLS-1$ //$NON-NLS-2$
			preventCache: true,
			handleAs: "json", //$NON-NLS-1$
			load: dojo.hitch(this, function(response, ioArgs){				
				self.permissions = com.ibm.relm.explorer.web.ui.internal.util.parsePermission(response);
				self._updateActions();

				// get list of queries and display them
				self._refreshContent();
			}),
			error: function(error) {
				alert(error.message);
			}
		});

	},
	
	_runNewQueryForView: function(event){
		if(this._callCount > 0) {
			return;
		}
		this._refreshContent();
	},

	_runNewQuery: function() {
		var self = this;
		if(self._callCount > 0) {
			return;
		}
		self._refreshContent();
	},

	// should be called before ExplorerClient call
	_incCount: function() {
		if(this._callCount == 0) {
			this.metanav._toolbar.disableButton(this.refreshButton);
			JazzUIWorkbench.showMessage(this._messages.ExecutingQuery);
		}
		this._callCount++;
	},
	
	// should be called in ExplorerClient callbacks
	_decCount: function() {
		this._callCount--;
		if(this._callCount <= 0) {
			this.metanav._toolbar.enableButton(this.refreshButton);
			JazzUIWorkbench.hideMessageArea();
			this._callCount = 0;
			if(	this._prevSelectedRow) {
				this._prevSelectedRow.scrollIntoView();
				dijit.focus(this._prevSelectedRow.children[0].lastChild);
				this._prevSelectedRow = null;
				this._previousSelectedQueryUri = null;
			}
		}
	},
	
	_refreshContent: function(pageUrl) { // was _runNewQuery
		this.inherited(arguments);
		this.messageArea.hideMessage();
		this.floatQueries = true;
		var self = this;

		this.refreshTabs();

		var title = this.shared ? this._messages.SharedQueries : this._messages.PrivateQueries;
		JazzUIWorkbench.setTitle(title);

		var responseHandler = new ServiceResponseHandler(
				self,
				"_renderRootFolders", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ExplorerClient.getSystemRootFolderDescriptors(responseHandler);
	},	

	refreshTabs:function() {
		this.myQueriesTab.set('checked', !this.shared); //$NON-NLS-1$
		this.sharedQueriesTab.set('checked', this.shared); //$NON-NLS-1$
	},
	
	_emptyTable: function() {
		var widgets = dijit.findWidgets(this._table.domNode);
		dojo.forEach(widgets, function(widget) {
			widget.destroyRecursive();
		});
		this._table.clearBody();
	},

	getTr: function(guid) {
		return dojo.byId(guid); 
	},
	
	_getFoldersFromResult: function(response){

		var self = this;
		return dojo.map(response.results.bindings, function(r){
			return { 
				"name": { //$NON-NLS-1$
					label: r.name.value, 
					type: "uri", //$NON-NLS-1$
					value: r.uri.value
				}, 
				"children" : { folders: [], queries: []}, //$NON-NLS-1$
				"description": (r.description) ? r.description.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"creator": r.creator, //$NON-NLS-1$
				"modified": (r.modified) ? r.modified.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"ownedBy": (r.ownedBy) ? r.ownedBy.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"shared": self.shared , //$NON-NLS-1$
				"parentUUID": (r.parentUuid) ? r.parentUuid.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"folderUUID": (r.folderUUID) ? r.folderUUID.value : "" //$NON-NLS-1$ //$NON-NLS-2$
			};
		});
	},
	
	// The root folders here are either "shared" or "my queries"
	// callback
	_renderRootFolders: function(response) {
		var folders = this._getFoldersFromResult(response);

		if (folders.length != 2) {
			// Something went wrong
			console.error("Root folder for Queries contains " + folders.length + " folder(s).: \n" + dojo.toJson(folders)); //$NON-NLS-1$ //$NON-NLS-2$
			this._decCount();
			return;
		}
		var index = (this.shared == true) ? 1 : 0;
		this._rootFolder = folders[index];
		this._rootUUID = this._rootFolder.folderUUID;
		this._folders[this._rootUUID] = this._rootFolder;
		this._renderChildFoldersForParent(this._rootFolder.folderUUID, true);
		this._renderChildsWithoutProjectArea();
		this._decCount();
	},

	// get the childs under root folder without project area property (for migration)
	_renderChildsWithoutProjectArea: function() {
		var args = {
				scope: (this.shared) ? "shared" : "personal", //$NON-NLS-1$ //$NON-NLS-2$
				sortByName: true
		};
		
		var responseHandler = new ServiceResponseHandler(
				this,
				"_addChildFoldersNonpa", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ExplorerClient.getFolderDescriptorsUnderNonProjectAreaRootFolder(responseHandler, args);
		var args2 = {
				scope: (this.shared) ? "shared" : "personal", //$NON-NLS-1$ //$NON-NLS-2$
				sortByName: true
		};
		if (this._currentFilter) {
			args2.filter = this._currentFilter;
		}
		var responseHandler2 = new ServiceResponseHandler(
				this,
				"_addChildQueriesNonpa", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ExplorerClient.getQueryDescriptorsUnderNonProjectAreaRootFolder(responseHandler2, args2);
	},

	// Gets the child folders for either "shared queries" or "my queries"
	_renderChildFoldersForParent: function(folderUUID, fShow){

		this._emptyTable();
		this._updateActions();
		if (this._runQueryTimeout) {
			clearTimeout(this._runQueryTimeout);
			delete this._runQueryTimeout;
		}
		if (!this._nextQueryId)
			this._nextQueryId = 1;
		var args = {
//				Project Area will be added by ExplorerClient
//				Owner is intentionally empty
				parentUUID: folderUUID,
				flags: ExplorerClient.ALL,
				sortByName: true
		};
		
		var responseHandler = new ServiceResponseHandler(
				this,
				(fShow) ? "_addChildFoldersShow" : "_addChildFoldersHide", //$NON-NLS-1$ //$NON-NLS-2$
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ExplorerClient.getFolderDescriptors(responseHandler, args);
		var args2 = {
//				Project Area will be added by ExplorerClient
//				Owner is intentionally empty
				parentUUID: folderUUID,
				sortByName: true
		};
		if (this._currentFilter) {
			args2.filter = this._currentFilter;
		}
		var responseHandler2 = new ServiceResponseHandler(
				this,
				(fShow) ? "_addChildQueriesShow" : "_addChildQueriesHide", //$NON-NLS-1$ //$NON-NLS-2$
		"_remoteError"); //$NON-NLS-1$
		this._incCount();
		ExplorerClient.getQueryDescriptors(responseHandler2, args2);
		// for queries which do not belong to any folder
		if(this.floatQueries) {

			var args3 = {
					parentUUID: "", //$NON-NLS-1$
					scope: (this.shared) ? "shared" : "personal", //$NON-NLS-1$ //$NON-NLS-2$
							sortByName: true
			};
			if (this._currentFilter) {
			args3.filter = this._currentFilter;
			}
			var responseHandler3 = new ServiceResponseHandler(
					this,
					(fShow) ? "_addChildQueriesShow" : "_addChildQueriesHide", //$NON-NLS-1$ //$NON-NLS-2$
			"_remoteError"); //$NON-NLS-1$
			this._incCount();
			ExplorerClient.getQueryDescriptors(responseHandler3, args3);
		}
	},

	// callback
	_addChildFoldersNonpa: function(response) {
		response.nonpaFolder = true;
		this._addChildFolders(response, true);
		this._decCount();
	},

	// callback
	_addChildFoldersShow: function(response) {
		this._addChildFolders(response, true);
		this._decCount();
	},

	// callback
	_addChildFoldersHide: function(response) {
		this._addChildFolders(response, false);
		this._decCount();
	},

	_addChildFolders: function(response, fShow) {
		PlatformUI.getWorkbench().hideMessageArea();
//		How many filters are already in the list
		var results = this._getFoldersFromResult(response);

		if (results != null) {
			this._performSort(results);
			for (var i = 0; i < results.length; i++) {
				var folder = results[i];
				this._childMap[folder.folderUUID] = new Array();
				this._folders[folder.folderUUID] = folder;
//				Locate the parent to insert it under
				if (folder.parentUUID == this._rootFolder.folderUUID || folder.parentUUID == null || response.nonpaFolder) {
					var folderRow = this._createFolderRow(folder, 9, fShow);
					this._table.tbody.appendChild(folderRow);
					this._rootFolder.children.folders.push(folder);
				} else {
					var parentUUID = folder.parentUUID;
					var parentDiv = this.getTr(parentUUID);
					this.showExpando(parentDiv, true);
					var parentObj = this._folders[parentUUID];
					if (parentDiv == null || parentObj == null) {
						console.warn("Parent not found for folder"); //$NON-NLS-1$
					} else {
						this._childMap[folder.parentUUID].push(folder.folderUUID); //MFV added folders to the child map to handle click on parent folder checkbox
						this._insertAfter(this._createFolderRow(folder, parentDiv._indent + INDENT, fShow), this._getFolderInsertionPoint(parentDiv));
						parentObj.children.folders.push(folder);
					}
				}
			}
//			Recurse
			for (var i = 0; i < results.length; i++) {
				var folder = results[i];
				var args = {
//						Project Area will be added by ReportsClient
//						Owner is intentionally empty
						parentUUID: folder.folderUUID,
						flags: ExplorerClient.ALL,
						sortByName: true
				};
				var responseHandler = new ServiceResponseHandler(
						this,
						(this._colexpState[folder.folderUUID]) ? "_addChildFoldersShow" : "_addChildFoldersHide", //$NON-NLS-1$ //$NON-NLS-2$
				"_remoteError"); //$NON-NLS-1$
				this._incCount();
				ExplorerClient.getFolderDescriptors(responseHandler, args);
				var args2 = {
//						Project Area will be added by ReportsClient
//						Owner is intentionally empty
						parentUUID: folder.folderUUID,
						sortByName: true
				};
				if (this._currentFilter) {
					args2.filter = this._currentFilter;
				}
				var responseHandler2 = new ServiceResponseHandler(
						this,
						(this._colexpState[folder.folderUUID]) ? "_addChildQueriesShow" : "_addChildQueriesHide", //$NON-NLS-1$ //$NON-NLS-2$
				"_remoteError"); //$NON-NLS-1$
				this._incCount();
				ExplorerClient.getQueryDescriptors(responseHandler2, args2);
			}
		}
	},

	_getFolderInsertionPoint: function(folderTRNode) {
		var candidate = folderTRNode;
		var nextCandidate = candidate.nextSibling;
		while (true) {
			if (nextCandidate == null) {
				return candidate;
			}
			var tmp2 = folderTRNode._indent + (INDENT2 - INDENT);
			var tmp = nextCandidate._indent < tmp2;
			if (nextCandidate._rowType == QUERYTYPE || tmp){
				return candidate;
			}
			candidate = nextCandidate;
			nextCandidate = nextCandidate.nextSibling;
		} 
	},
	_getQueriesFromResult: function(response) {
		var self = this;
		return dojo.map(response.results.bindings, function(r){
			return { 
				"name": { //$NON-NLS-1$
					label: r.title.value, 
					type: "uri", //$NON-NLS-1$
					value: r.uri.value,
					alt: this._messages.queryAlt,
					iconSrc: dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/query.gif") //$NON-NLS-1$ //$NON-NLS-2$
				}, 
				"description": (r.description) ? r.description.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"creator": r.creator, //$NON-NLS-1$
				"modified": (r.modified) ? r.modified.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"shared": self.shared , //$NON-NLS-1$
				"parentUUID": (r.parentUUID) ? r.parentUUID.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"parameterized": (r.parameterized) ? r.parameterized.value : "", //$NON-NLS-1$ //$NON-NLS-2$
				"ownedBy": (r.ownedBy) ? r.ownedBy.value : "" //$NON-NLS-1$ //$NON-NLS-2$
			};
		}, this);

	},

	// callback
	_addChildQueriesNonpa: function(response) {
		response.nonpaQueries = true;
		this._addChildQueries(response, true);
		this._decCount();
	},
	// callback
	_addChildQueriesShow: function(response) {
		this._addChildQueries(response, true);
		this._decCount();
	},
	// callback
	_addChildQueriesHide: function(response) {
		this._addChildQueries(response, false);
		this._decCount();
	},
	_addChildQueries: function(response, fShow) {
		var results = this._getQueriesFromResult(response);
		PlatformUI.getWorkbench().hideMessageArea();
		if (results != null) {
			this._performSort(results);
			for (var i = 0; i < results.length; i++) {
				var query = results[i];
				if (this._childMap[query.parentUUID] == null)
					this._childMap[query.parentUUID] = new Array();
				this._childMap[query.parentUUID].push(query.name.value);
//				Locate the parent to insert it under
				if (query.parentUUID == this._rootFolder.folderUUID || query.parentUUID == "" || response.nonpaQueries) { //$NON-NLS-1$
					this._table.tbody.appendChild(this._createQueryRow(query, 29, fShow));
					this._rootFolder.children.queries.push(query);
				} else {
					var parentFolder = this.getTr(query.parentUUID);
					if (parentFolder == null) {
//						Couldn't find the folder, so must be a root folder
						this._table.tbody.appendChild(this._createQueryRow(query, 29, fShow));
						this._rootFolder.children.queries.push(query);
					} else {
						this.showExpando(parentFolder, true);
						var parentUUID = query.parentUUID;
						this._insertAfter(this._createQueryRow(query, parentFolder._indent + INDENT2, fShow), this._getQueryInsertionPoint(parentUUID));
						this._folders[parentUUID].children.queries.push(query);
					}
				}
			}
		}
	},


	_getQueryInsertionPoint: function(folderUUID) {
		var folderTRNode = this.getTr(folderUUID);
		var candidate = folderTRNode;
		var nextCandidate = candidate.nextSibling;
		while (true) {
			if (nextCandidate == null) {
				return candidate;
			}
			if (nextCandidate._rowType == FOLDERTYPE || nextCandidate._indent <= folderTRNode._indent + (INDENT2 - INDENT)){
				return candidate;
			}
			candidate = nextCandidate;
			nextCandidate = nextCandidate.nextSibling;
		} 
	},
	

	_createQueryRow: function(query, padding, fShow) {
		var messages = this._messages;
		query._explorerTemp_ = {};
		var row = document.createElement("tr"); //$NON-NLS-1$
		row._indent = padding;
		row._rowType = QUERYTYPE;
		row._name = query.name.label;
		row._creator = this._getDisplayValue(query.creator);
		row._modified = query.modified;
		row.id = query.name.value;
		row.folderID = query.parentUUID; //Save this so we can find the folder row easily
		row.style.display = (fShow) ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$
		var td = document.createElement("td"); //$NON-NLS-1$
//		Create the checkbox
		var cb = document.createElement("input"); //$NON-NLS-1$
		cb.style.paddingRight = "5px"; //$NON-NLS-1$
		cb.type = "checkbox"; //$NON-NLS-1$
		cb.checked = false;
		cb.title = messages.toggleRowSelection;

		this.connect(cb, "ondijitclick", this._handleQueryCheckBoxClick); //$NON-NLS-1$

//		The query image
		var img = document.createElement("img"); //$NON-NLS-1$
		img.alt = ''; //$NON-NLS-1$
		img.src = query.name.iconSrc;
		img.classname = "row-image"; //$NON-NLS-1$
		img.style.paddingLeft = "5px"; //$NON-NLS-1$
		img.style.paddingRight= "5px"; //$NON-NLS-1$
		td.style.paddingLeft = padding + "px"; //$NON-NLS-1$
		td.className="queryName"; //$NON-NLS-1$
//		append the checkbox and icon
		td.appendChild(cb);
		td.appendChild(img);
		this._formatResource(query.name, td, query);

//		append the td to the row
		row.appendChild(td);
//		Create the query creator
		td = document.createElement("td"); //$NON-NLS-1$
		td.className = "queryName"; //$NON-NLS-1$
		this._formatResource(query.creator, td, null);
		row.appendChild(td);
//		Create the query modified
		td = document.createElement("td"); //$NON-NLS-1$
		td.className = "queryName"; //$NON-NLS-1$
		td.innerHTML = this._formatDateTime(query.modified);
		row.appendChild(td);
//		Create the actions
		td = document.createElement("td"); //$NON-NLS-1$
		td.className = "action-column"; //$NON-NLS-1$
		span = document.createElement("span"); //$NON-NLS-1$
		span.className = "actionBar"; //$NON-NLS-1$
		var toolbar = new com.ibm.relm.explorer.web.explorer.page.Toolbar({});
		if(this.shared) {
			if(this.permissions.modifyPermission)
				toolbar.addButton(this, dojo.hitch(this, "_editQuery", query), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if(this.permissions.deletePermission)
				toolbar.addButton(this, dojo.hitch(this, "_deleteQuery", query), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/delete.gif"), label: messages.deleteQueryMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			// always enable copy/move button
			toolbar.addButton(this, dojo.hitch(this, "_moveQuery", query), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/movecopy.gif"), label: messages.moveQuery}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		} else {
			toolbar.addButton(this, dojo.hitch(this, "_editQuery", query), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_deleteQuery", query), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/delete.gif"), label: messages.deleteQueryMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_moveQuery", query), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/movecopy.gif"), label: messages.moveQuery}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		}
		span.appendChild(toolbar.domNode);
		td.appendChild(span);
		row.appendChild(td);
		if(query.name.value == this._previousSelectedQueryUri) {
			this._prevSelectedRow = row;
		}
		return row;
	},
	_createFolderRow: function(folder, padding, fShow) {
		var messages = this._messages;
		folder._explorerTemp_ = {};
		var row = dojo.create('tr', { //$NON-NLS-1$
			id: folder.folderUUID,
			"class": "noChildren" //$NON-NLS-1$ //$NON-NLS-2$
		});
		row._indent = padding;
		row._rowType = FOLDERTYPE;
		row._name = folder.name.label;
		row._creator = this._getDisplayValue(folder.creator);
		row._modified = folder.modified;
		row.id = folder.folderUUID;
		if(this._colexpState[folder.folderUUID] == undefined) {
			this._colexpState[folder.folderUUID] = false;
		}
		(this._colexpState[folder.folderUUID]) ? row._expanded = "true" : row._expanded = "false"; //$NON-NLS-1$ //$NON-NLS-2$
		row.style.display = (fShow) ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$
		td = document.createElement("td"); //$NON-NLS-1$
		td.style.paddingLeft = padding + "px"; //$NON-NLS-1$
		td.className="folderName"; //$NON-NLS-1$
//		Create collapse expand	
		var colImg = dojo.create('img', { //$NON-NLS-1$
			src: (this._colexpState[folder.folderUUID]) ? COLLAPSE_ICON : EXPAND_ICON,
			classname: 'collapse-expand-img', //$NON-NLS-1$
			alt: this._messages.toggleOpenClose,
			style: {
				padding: "0 5px" //$NON-NLS-1$
			},
			tabindex: 0
		});
		colImg.folderID = folder.folderUUID;
		this.connect(colImg, "ondijitclick", this._handleFolderColExp); //$NON-NLS-1$
		td.appendChild(colImg);
//		Create the checkbox
		var cb = document.createElement("input"); //$NON-NLS-1$
		cb.type = "checkbox"; //$NON-NLS-1$
		cb.checked = false;
		cb.style.paddingRight= "5px"; //$NON-NLS-1$
		cb.folderID = folder.folderUUID;
		cb.title = this._messages.toggleRowSelection;
		this.connect(cb, "onclick", this._handleFolderCheckBoxClick); //$NON-NLS-1$
		td.appendChild(cb);
//		Folder image
		var img = document.createElement("img"); //$NON-NLS-1$
		img.src = dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/folder.gif"); //$NON-NLS-1$ //$NON-NLS-2$
		img.alt = this._messages.folderAlt;
		img.classname = "row-image"; //$NON-NLS-1$
		img.style.paddingLeft = "5px"; //$NON-NLS-1$
		img.style.paddingRight= "5px"; //$NON-NLS-1$
//		Create the text node to hold the folder name
		var textNode = document.createTextNode(" " + folder.name.label); //$NON-NLS-1$
		td.appendChild(img);
		td.appendChild(textNode);
		row.appendChild(td);
//		Create the creator
		td = document.createElement("td"); //$NON-NLS-1$
		td.className = "folderName"; //$NON-NLS-1$
		this._formatResource(folder.creator, td, null);
		row.appendChild(td);
//		Create the modified
		td = document.createElement("td"); //$NON-NLS-1$
		td.className = "folderName"; //$NON-NLS-1$
		td.innerHTML = this._formatDateTime(folder.modified);
		row.appendChild(td);
//		Create the actions
		td = document.createElement("td"); //$NON-NLS-1$
		td.className = "action-column"; //$NON-NLS-1$
		span = document.createElement("span"); //$NON-NLS-1$
		span.className = "actionBar"; //$NON-NLS-1$
		var toolbar = new com.ibm.relm.explorer.web.explorer.page.Toolbar({});
		if(this.shared){
			if(this.permissions.createPermission)
				toolbar.addButton(this, dojo.hitch(this, "_createNewFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/new-folder-obj.gif"), label: messages.createFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if(this.permissions.modifyPermission)
				toolbar.addButton(this, dojo.hitch(this, "_editFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if(this.permissions.deletePermission) 
				toolbar.addButton(this, dojo.hitch(this, "_deleteFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/delete.gif"), label: messages.deleteMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			// always enable copy/move button
			toolbar.addButton(this, dojo.hitch(this, "_moveFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/movecopy.gif"), label: messages.moveFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		} else {
			toolbar.addButton(this, dojo.hitch(this, "_createNewFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/new-folder-obj.gif"), label: messages.createFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_editFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/edit.gif"), label: messages.edit}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_deleteFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/delete.gif"), label: messages.deleteMsg}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			toolbar.addButton(this, dojo.hitch(this, "_moveFolder", folder), {imgSrc: dojo.moduleUrl("com.ibm.relm.explorer.web","ui/images/movecopy.gif"), label: messages.moveFolder}); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		}
		span.appendChild(toolbar.domNode);
		td.appendChild(span);
		row.appendChild(td);
		return row;
	},

	_formatDateTime: function (value) {
		sortValue = dojo.date.stamp.fromISOString(value); // convert created to Date type
		if(sortValue){
			displayValue = dojo.date.locale.format(sortValue, {formatLength: "medium"}); //$NON-NLS-1$
		}
		
		return displayValue;
	},

	_getDisplayValue: function(valueObject) {
		var value = valueObject.value;
		if (valueObject.label)
			return valueObject.label;
		else {
			var displayValue = decodeURIComponent(value.substring(value.lastIndexOf('/') + 1)); //$NON-NLS-1$
			//Try to cache the label so it doesn't need to computed again when sorting
			valueObject.label = displayValue;
			return displayValue;
		}
	},
	
	_formatResource: function (value, td, resource) {
		var self = this;
		var displayValue = value.value;
		if(displayValue){
			displayValue = this._getDisplayValue(value);
			var link = dojo.create("a", {href: "#edit", target: "",  innerHTML: displayValue, title: value.value}, td); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
            link.resource = resource;
            link._uri_ = value.value;
            link._name_ = displayValue;
			var rl = new jazz.ui.ResourceLink( { 
				uri: value.value, 
				lazyFetch: false, 
				retainLinkText: false,
				target: "", //$NON-NLS-1$
				useAbbreviation: false }, link);
			if(resource) {
	            link._parameterized = resource.parameterized;
	            link._conceptResourceUri_ = value.conceptResourceUri;
				self.connect(link, "onclick", function(evt){ //$NON-NLS-1$
					self.onResourceSelected(evt.target);
					dojo.stopEvent(evt);
				});
				if(!resource._explorerTemp_._uri_){
					// used in onDelete
					// assumes the first uri is the resource uri
					resource._explorerTemp_._uri_ = value.value;
					resource._explorerTemp_._name_ = displayValue;
				}
			}
            sortValue = displayValue; // sort by displayed string
            displayValue = null;
 		}
		if(td && displayValue){
			td.innerHTML = displayValue;
		}

	},
	
	_insertAfter: function(newNode, referenceNode) {
		referenceNode.parentNode.insertBefore(newNode, referenceNode.nextSibling);
	},

	/**
	 * Toggles showing of the expando on a folder row
	 * @param  {Tr} folderRow       The folder row with the expando
	 * @param  {boolean} condition True indicates showing, False indicates hiding
	 */
	showExpando: function(folderRow, condition) {
		dojo.toggleClass(folderRow, 'noChildren', !condition); //$NON-NLS-1$
	},

	_handleFolderColExp: function(args) {
		var folderRow = args.currentTarget.parentNode.parentNode;
		var fShow = (folderRow._expanded == "false") ? "true" : "false"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		folderRow._expanded = fShow;
		this._collapseExpandFolder(folderRow, fShow);
		args.currentTarget.src = (fShow == "true") ?  COLLAPSE_ICON : EXPAND_ICON ; //$NON-NLS-1$
		
	},

	_collapseExpandFolder: function(folderRow, fShow) 
	{
		this._colexpState[folderRow.id] = !this._colexpState[folderRow.id];
		dojo.forEach(this._childMap[folderRow.id], function(childID) {
			var childRow = this.getTr(childID); 
			childRow.style.display = (fShow == "true") ? "" : "none"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if(childRow._rowType == FOLDERTYPE) { 
				if(childRow._expanded == "true") { //$NON-NLS-1$
					this._collapseExpandFolder(childRow, fShow);
					
				}
			}	
		}, this);
	},

	_handleQueryCheckBoxClick: function(args)
	{
		var checkedState = args.currentTarget.checked;

		//if we unchecked a report then make sure the folder is unchecked also
		if (checkedState == false)
			this._setRowCheckedState(args.currentTarget.parentNode.parentNode.folderID, false);

		this._updateActions();
	},
	_handleFolderCheckBoxClick: function(args)
	{
		var checkedState = args.currentTarget.checked;
		var folderID = args.currentTarget.folderID;
		this._handleFolderCheck(folderID, checkedState);
		this._updateActions();
	},
	
	_handleFolderCheck: function(folderID, checkedState)
	{
		var childIDs = this._childMap[folderID];
		for (var i = 0; i < childIDs.length; i++)
		{
			var childID = childIDs[i];
			this._setRowCheckedState(childID, checkedState);
			if (this._childMap[childID] != null)   //Recurse child nodes
				this._handleFolderCheck(childID, checkedState);
		}
	},
	
	_getCheckboxFromTR: function(trNode)
	{
		if(trNode._rowType == "folder") { //$NON-NLS-1$
			return trNode.children[0].children[1];  //First child is the <td> second child of that is the input (checkbox);
		} else {
			return trNode.children[0].children[0];  //First child is the <td> first child of that is the input (checkbox);
		}
	},
	
	_isRowChecked: function(trNode)
	{
		return this._getCheckboxFromTR(trNode).checked;
	},
	
	_setRowCheckedState: function(rowID, checkedState)
	{
		var tr = this.getTr(rowID);
		if(!tr) return;
		var cb = this._getCheckboxFromTR(tr);
		cb.checked = checkedState;
	},
	
	_updateActions: function()
	{
		var buttonCounter = 0;
		var button = null;
		while((button = this.metanav._toolbar.getItem(buttonCounter++)) != null)
		{
			if(this.shared) {
				if(button.args.requireCreate) {
					if (this.permissions.createPermission) {
						this._updateRequireSelection(button);
					} else {
						this.metanav._toolbar.disableButton(button);
					}
				}
				if(button.args.requireModify) {
					if (this.permissions.modifyPermission) {
						this._updateRequireSelection(button);
					} else {
						this.metanav._toolbar.disableButton(button);
					}
				}
				if(button.args.requireDelete) {
					if (this.permissions.deletePermission) {
						this._updateRequireSelection(button);
					} else {
						this.metanav._toolbar.disableButton(button);
					}
				}
				if(button.args.moveCopy) {
					this._updateRequireSelection(button);
				}
				if(button.args.matrix) {
					this._updateRequireSelection(button);
				}
			} else {
				// private
				this._updateRequireSelection(button);
			}
		}
	},
	
	_updateRequireSelection: function(button) 
	{
		var rowsChecked = this._getCheckedCount() > 0;
		if (button.args.requiresSelection)
		{
			if (rowsChecked)
				this.metanav._toolbar.enableButton(button);
			else
				this.metanav._toolbar.disableButton(button);
		}
		
	},

	_deleteItems: function()
	{
		var messages = this._messages;
		var items = this._getCheckedItems(true);
		if (items.length <= 0)
			return;
			
		var queryItemIDs = [];
		var folderItemIDs = [];

		for (var i = 0; i < items.length; i++)
		{
			var item = items[i];
			if (item.rowType == QUERYTYPE)
				queryItemIDs.push(item.id);
			else if (item.rowType == FOLDERTYPE)
				folderItemIDs.push(item.id);
		}

		var confirmMsg = ""; //$NON-NLS-1$
		if (queryItemIDs.length > 0 && folderItemIDs.length > 0)
			confirmMsg = dojo.string.substitute(messages.confirmDelQueriesAndFolders, [queryItemIDs.length, folderItemIDs.length]);
		else if (queryItemIDs.length > 0)
			confirmMsg = dojo.string.substitute(messages.confirmDelQueries, [queryItemIDs.length]);
		else
			confirmMsg = dojo.string.substitute(messages.confirmDelFolders, [folderItemIDs.length]);
		
		if (!window.confirm(confirmMsg)) {
			return;
		}

		this._deletedTypes = 0;
		//Delete the queries if any
		if (queryItemIDs.length > 0) 
		{
			this._deletedTypes++;
			var args = {
    			queryURIs: queryItemIDs
    		};
			var responseHandler = new ServiceResponseHandler(this, "_queriesDeleted", "_remoteError"); //$NON-NLS-1$ //$NON-NLS-2$
			ExplorerClient.postDeleteQueryDescriptors(responseHandler, args);
		}
		
		if (folderItemIDs.length > 0) 
		{
			this._deletedTypes++;
			var folderArgs = {
				folderUUIDs: folderItemIDs
			};
			//Delete the folders
			var responseHandler = new ServiceResponseHandler(this, "_queriesDeleted", "_remoteError"); //$NON-NLS-1$ //$NON-NLS-2$
			ExplorerClient.postDeleteFolderDescriptors(responseHandler, folderArgs);
		}		
	},

	_moveItems: function()
	{
		var messages = this._messages;
		var items = this._getCheckedItems(true);
		if (items.length <= 0)
			return;
			
		var queryURIs = [];
		var queryNames = [];
		var folderUUIDs = [];
		var folderNames = [];

		for (var i = 0; i < items.length; i++)
		{
			var item = items[i];
			if (item.rowType == QUERYTYPE) 
			{
				queryURIs.push(item.id);
				queryNames.push(item.name.label);
			}
			else if (item.rowType == FOLDERTYPE)
			{
				folderUUIDs.push(item.id);
				folderNames.push(item.name.label);
			} 
		}
		
		var args = {
			folderUUIDs: folderUUIDs,
			folderNames: folderNames,
			queryURIs: queryURIs,
			queryNames: queryNames,
			shared: this.shared,
			permissions: this.permissions,
			
			parentUUID: null,

			okCallback: dojo.hitch(this,this._okDialogCallback),
			cancelCallback: dojo.hitch(this,this._cancelDialogCallback)
		};
		var moveQuery = new com.ibm.relm.explorer.web.explorer.page.MoveQuery(args);
		
		this._dialog = new jazz.ui.Dialog({
			contentNode: moveQuery.mainDiv,
			primaryTitle: messages.moveQuery,
			width: "300px", //$NON-NLS-1$
			isClosable: true
		});
		
		
	},
	_queriesDeleted: function(args)
	{
		this._deletedTypes--;
		if (this._deletedTypes <= 0)
			this._runNewQuery();
	},
	

	_newFolder: function() {
		var isShared = (this.shared == true) ? "true" : "false"; //$NON-NLS-1$ //$NON-NLS-2$
		window.location.href = this.editFolderAction + "&mode=create&folderType=query&shared=" + isShared; //$NON-NLS-1$
	},
	_newQuery: function() {
		window.location.href = this.createQueryAction;
	},

	_createNewFolder: function(folder) {
		var isShared = (this.shared == true) ? "true" : "false"; //$NON-NLS-1$ //$NON-NLS-2$
		window.location.href = this.editFolderAction + "&mode=create&folderType=query&parentUUID=" + folder.folderUUID + /*"&processAreaUUID=" + folder.processAreaUUID +*/ "&shared=" + isShared; //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	_editQuery: function(r)
	{
    	window.location.href = "#action=com.ibm.relm.explorer.web.showExplorer&edit=true&queryUri="+r.name.value+"&queryName="+encodeURIComponent(r.name.label); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_editFolder: function(folder) {
		window.location.href = this.editFolderAction + "&mode=modify&folderType=query&folderUUID=" + folder.folderUUID; //$NON-NLS-1$
	},

	_filterDeletedFolder: function(deleted, root){
		if(deleted.parentUUID == root.folderUUID){
			root.children.folders = dojo.filter(root.children.folders, function(item){
		    	return item.name.value != deleted.name.value;
			});
		}
		else if(root.children.folders.length >0){
				var self = this;
				dojo.forEach(root.children.folders, function(entry,i){
    				entry = self._filterDeletedFolder(deleted,entry);
  				});
		}
		return root;
	},
	_deleteFolder: function(folder) {
		var messages = this._messages;
		if (!confirm(dojo.string.substitute(messages.confirmDelFolder, [folder.name.label]))) {
			return;
		}
		var args = {
				folderUUID: folder.folderUUID
		};
		var responseHandler = new ServiceResponseHandler(
				this,
				"_folderDeleted", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		var rowNode = dojo.query("tr[id=" + folder.folderUUID + "]"); //$NON-NLS-1$ //$NON-NLS-2$
		if(rowNode.length > 0){
			rowNode = rowNode[0];
			this._pendingDeleteFolderNode = rowNode;
		}
//		find all of the child nodes
		this._pendingDeleteFolderChildrenNodes = new Array();
		this._addAllChildQueriesToFolderDelete(folder.folderUUID);
		ExplorerClient.postDeleteFolderDescriptor(responseHandler, folder.folderUUID, args);
		this._rootFolder = this._filterDeletedFolder(folder, this._rootFolder);
		ExplorerClient.postDeleteQueryDescriptor(responseHandler, args);
	},
	_addAllChildQueriesToFolderDelete: function(uuid){
		var folderChildren = this._childMap[uuid];
		if(folderChildren){
			for(var i = 0; i < folderChildren.length; i++){
				var child = this.getTr(folderChildren[i]); 
				if(child){
					this._pendingDeleteFolderChildrenNodes.push(child);
					this._addAllChildQueriesToFolderDelete(child.id);
				}
			}
		}
	},
	_folderDeleted: function() {
		if(this._pendingDeleteFolderNode && this._pendingDeleteFolderNode != null){
			this._table.tbody.removeChild(this._pendingDeleteFolderNode);
			this._pendingDeleteFolderNode = null;
		}
		if(this._pendingDeleteFolderChildrenNodes && this._pendingDeleteFolderChildrenNodes != null){
			for(var i = 0; i < this._pendingDeleteFolderChildrenNodes.length; i++){
				this._table.tbody.removeChild(this._pendingDeleteFolderChildrenNodes[i]);
			}
			this._pendingDeleteFolderChildrenNodes = null;
		}
		console.debug("_folderDeleted"); //$NON-NLS-1$
		this._updateActions();
	},
	_filterDeletedQuery: function(deleted, root){
		if(deleted.parentUUID == root.folderUUID){
			root.children.queries = dojo.filter(root.children.queries, function(item){
		    	return item.name.value != deleted.name.value;
			});
		}
		else if(root.children.folders.length >0){
				var self = this;
				dojo.forEach(root.children.folders, function(entry,i){
    				entry = self._filterDeletedQuery(deleted,entry);
  				});
		}
		return root;
	},
	_deleteQuery: function(r) {
		var messages = this._messages;
		if (!confirm(dojo.string.substitute(messages.confirmDelQuery, [r.name.label]))) {
			return;
		}
		
		var args = {
				queryURI: r.name.value
		};
		var responseHandler = new ServiceResponseHandler(
				this,
				"_queryDeleted", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		var rowNode = this.getTr(r.name.value); 
		if(rowNode){
			this._pendingDeleteQueryNode = rowNode;
		}
		ExplorerClient.postDeleteQueryDescriptor(responseHandler, args);
		this._rootFolder = this._filterDeletedQuery(r,this._rootFolder);
	},
	_queryDeleted: function() {
		if(this._pendingDeleteQueryNode && this._pendingDeleteQueryNode != null){
			this._table.tbody.removeChild(this._pendingDeleteQueryNode);
			this._pendingDeleteQueryNode = null;
		}
		console.debug("_queryDeleted"); //$NON-NLS-1$
		this._updateActions();
	},
	_moveQuery: function(query)
	{
		var messages = this._messages;
		var queryURIs = [query.name.value];
		var queryNames = [query.name.label];
		var args = {
				queryURIs: queryURIs,
				queryNames: queryNames,
				shared: this.shared,
				permissions: this.permissions,
				parentUUID: (this.permissions.createPermission && (query.parentUUID != null)) ? query.parentUUID : "", //$NON-NLS-1$
						okCallback: dojo.hitch(this,this._okDialogCallback),
						cancelCallback: dojo.hitch(this,this._cancelDialogCallback)
		};
		var moveQuery = new com.ibm.relm.explorer.web.explorer.page.MoveQuery(args);
		this._dialog = new jazz.ui.Dialog({
			contentNode: moveQuery.mainDiv,
			primaryTitle: messages.moveQuery,
			width: "400px", //$NON-NLS-1$
			isClosable: true
		});
	},
	_moveFolder: function(folder)
	{
		var messages = this._messages;
		var folderUUIDs = [folder.folderUUID];
		var folderNames = [folder.name.label];
		var args = {
				folderUUIDs:folderUUIDs,
				folderNames: folderNames,
				shared: this.shared,
				permissions: this.permissions,
				parentUUID: (this.permissions.createPermission && (folder.parentUUID != null)) ? folder.parentUUID : "", //$NON-NLS-1$
						okCallback: dojo.hitch(this,this._okDialogCallback),
						cancelCallback: dojo.hitch(this,this._cancelDialogCallback)
		};
		var moveQuery = new com.ibm.relm.explorer.web.explorer.page.MoveQuery(args);
		this._dialog = new jazz.ui.Dialog({
			contentNode: moveQuery.mainDiv,
			primaryTitle: messages.moveFolder,
			width: "300px", //$NON-NLS-1$
			isClosable: true
		});
	},

	_generateMatrix: function(){
		var items = this._getCheckedItems(false);
		if (items.length <= 0)
			return;			
		var queries = [];
		for (var i = 0; i < items.length; i++) {
			var item = items[i];
			if (item.rowType == QUERYTYPE)
				queries.push(item);
		}

		if (queries.length > 0)	{
			var wizard = new com.ibm.relm.explorer.web.explorer.matrix.CreateMatrixWizard({
				permissions: this.permissions,
				queries: queries,
				primaryTitle: this._messages.generateMatrix,
				width: "70%", //$NON-NLS-1$
				customProcessFinish: function(){
					var matrixInfo = this.container.getMatrixInfo();
					
					var url = com.ibm.relm.explorer.web.ui.queryServiceUri + "?method=generateMatrix"; //$NON-NLS-1$
					//
					var form = dojo.create("form", {"name": "generateMatrix", "action":url, "method":'post'}, this.domNode); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					dojo.create("input", {"type":"hidden", "name":"rowVar", "value": matrixInfo.rowVar}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					dojo.create("input", {"type":"hidden", "name":"rowQueryURI", "value": matrixInfo.rowQueryURI}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					dojo.forEach(matrixInfo.rowValues.uris, function(v){
						dojo.create("input", {"type":"hidden", "name":"rowValues", "value": v}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					});
					dojo.forEach(matrixInfo.rowValues.titles||[], function(t){
						dojo.create("input", {"type":"hidden", "name":"rowTitles", "value": t}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					});
					dojo.create("input", {"type":"hidden", "name":"columnVar", "value": matrixInfo.columnVar}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					dojo.create("input", {"type":"hidden", "name":"columnQueryURI", "value": matrixInfo.columnQueryURI}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					dojo.forEach(matrixInfo.columnValues.uris, function(v){
						dojo.create("input", {"type":"hidden", "name":"columnValues", "value": v}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					});
					dojo.forEach(matrixInfo.columnValues.titles||[], function(t){
						dojo.create("input", {"type":"hidden", "name":"columnTitles", "value": t}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					});
					dojo.create("input", {"type":"hidden", "name":"relation", "value": dojo.toJson(matrixInfo.relations)}, form); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
					form.submit();
					this.domNode.removeChild(form);
				}
			});
			wizard.startup();
		}
	},

	_exportQueries: function(){
		var items = this._getCheckedItems(false);
		if (items.length <= 0)
			return;
			
		var queryItemIds = [];
		for (var i = 0; i < items.length; i++) {
			var item = items[i];
			if (item.rowType === QUERYTYPE) {
				queryItemIds.push(item.id);
			}
		}

		if (queryItemIds.length > 0)	{
			var url = com.ibm.relm.explorer.web.ui.queryServiceUri + "?method=exportQueries"; //$NON-NLS-1$

			var form = dojo.create("form", { //$NON-NLS-1$
				name: "exportQueries", //$NON-NLS-1$
				action: url,
				target: '_blank', //$NON-NLS-1$
				method: 'POST' //$NON-NLS-1$
			}, this.domNode);

			dojo.forEach(queryItemIds, function(id) {
				dojo.create("input", { //$NON-NLS-1$
					type: "hidden", //$NON-NLS-1$
					name: "queryURIs", //$NON-NLS-1$
					value: id
				}, form);
			});

			form.submit();
			this.domNode.removeChild(form);
		}
	},

	_doFilter: function(filter) {
		this._currentFilter = filter;
		this._isRelatedFilterState = true;
		// set a timeout to query with the new filter
		// need to ensure 0 is passed to _runQuery or setTimeout will pass some other value
		if (!this._runQueryTimeout) {
			this._runQueryTimeout = setTimeout(dojo.hitch(this,this._runNewQueryForView,0,true),500);
		}
	},
	
	_okDialogCallback: function(args)
	{
		this._dialog.close();
		this._dialog.destroy();
		var needRefresh = false;
		
		if((args.targetShared && this.scope == "shared") || (!args.targetShared && this.scope == "personal")) { //$NON-NLS-1$ //$NON-NLS-2$
			// target is same scope  -  refresh the current query list only
			needRefresh = true;
		} else {
			// target is different scope  -  refresh the current if the operation is move, and refresh target query list when it is shown next
			needRefresh = args.isMove;
			// enable refresh flag for another scope view list
			this.queryPage.setListDirty((args.targetShared)?"shared":"personal"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		if(needRefresh)	this._runNewQuery();
	},
	_cancelDialogCallback: function(args)
	{
		this._dialog.close();
		this._dialog.destroy();
	},


	_remoteError: function(error) {
		PlatformUI.getWorkbench().showMessage(error.message);
	},

	_getCheckedItems: function(excludeChildrenOfSelectedFolders)
	{
		var retVal = [];
		var body = this._table.tbody;
		var tableRows = body.children;
		for (var i = 0; i < tableRows.length; i++)
		{
			var row = tableRows[i];
			if (this._isRowChecked(row))
			{
				var selectedItem = {};
				selectedItem.rowType = row._rowType;
				selectedItem.id = row.id;
				selectedItem.name = row._name;
				retVal.push(selectedItem);
				//If we want to exclude children of selected folders
				if (excludeChildrenOfSelectedFolders && row._rowType == FOLDERTYPE)
				{
					//skip all the subsequent rows until the next sibling
					var indent = row._indent;
					while ((i+1 < tableRows.length) && 
							(((tableRows[i+1]._rowType == FOLDERTYPE)? tableRows[i+1]._indent : tableRows[i+1]._indent - INDENT) > indent))
						i++;
				}
			}
		}
		
		return retVal;
	},
		
	_getCheckedCount: function()
	{
		var retVal = 0;
		var body = this._table.tbody;
		var tableRows = body.children;
		for (var i = 0; i < tableRows.length; i++)
		{
			var row = tableRows[i];
			if (this._isRowChecked(row))
				retVal++;
		}
		
		return retVal;
	},
	
	// tool-bar actions
	onReload: function() {
    	this._refreshContent();
    },

    onShown: function() {
		var title = this.shared ? this._messages.SharedQueries : this._messages.PrivateQueries;
		JazzUIWorkbench.setTitle(title);

    	if(this._refreshRequired) {
    		this._emptyTable();
    		this._refreshContent();
    		this._refreshRequired = false;
    	} else {
    		// just change selected tab
    		this.refreshTabs();
    	}
    },
    onResourceSelected: function(target){
       	this._previousSelectedQueryUri = target._uri_;
		window.location.href = "#action=com.ibm.relm.explorer.web.showExplorer&queryUri="+target._uri_ + "&queryName="+encodeURIComponent(target._name_) + "&parameterized=" + target._parameterized; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
	},
	
    onEdit: function(r) {
    	window.location.href = "#action=com.ibm.relm.explorer.web.showExplorer&edit=true&queryUri="+r.name.value+"&queryName="+encodeURIComponent(r.name.label); //$NON-NLS-1$ //$NON-NLS-2$
    },
    
    onDelete: function(resource) {

    	var self = this;
    	jazz.client.xhrDelete({
            url: resource.name.value,
            handle: function(){
    			JazzUIWorkbench.hideMessageArea();	            	
            },
            load: function(data, ioArgs){
                // Render resource list 
        		self._refreshContent();
            }
    	});

    }

});
})();
