/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.base.internal.canvas.tool.DefaultCreationTool"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.canvas.tool.AbstractTool"); //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.base.internal.canvas.tool.DefaultCreationTool", //$NON-NLS-1$
	com.ibm.relm.explorer.web.base.internal.canvas.tool.AbstractTool,
{
	cursor: "pointer", //$NON-NLS-1$

	handleClick: function(e){
		this.fireToolOperationFinished(); // to deselect the palette
		var refWidget = this.findRefWidget(e);
		this.insertComponent(e, refWidget);
		this.getEditor().loadDefaultTool();
		this.getEditor().domNode.style.cursor = "auto"; //$NON-NLS-1$
	},

	handleDrop: function(e){
		var targetWidget = this.getDropTargetWidget(e);
		var type = e.dragSource.type;
		var ret = null;
		if(targetWidget[type+"DropHandler"]){ //$NON-NLS-1$
			ret = targetWidget[type+"DropHandler"](e, this); //$NON-NLS-1$
		}
		if(!ret && this[type+"DropHandler"]){ //$NON-NLS-1$
			ret = this[type+"DropHandler"](e); //$NON-NLS-1$
		}
		this.getEditor().loadDefaultTool();
		e.dragStatus = ret ? "dropSuccess" : "dropFailure"; // See DragManager.onMouseUp() //$NON-NLS-1$ //$NON-NLS-2$
		this.getEditor().domNode.style.cursor = ""; //$NON-NLS-1$
	},

	handleMouseOver: function(e){
		this.getEditor().domNode.style.cursor = "pointer"; //$NON-NLS-1$
	},

	componentDropHandler: function(e){
		// this: drop target widget
		var ret = null;
		if(this.getEditor().componentSpec){
			var refWidget = this.findRefWidget(e);
			ret = this.insertComponent(e, refWidget);
		}
		return ret;
	}
});
