/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.common.web.ui.DialogHelpHeader"); //$NON-NLS-1$

dojo.require('dijit._Templated'); //$NON-NLS-1$

(function(){
	dojo.declare(
		"com.ibm.relm.common.web.ui.DialogHelpHeader", //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.common.web','ui/templates/DialogHelpHeader.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,

			mainMessage: '', //$NON-NLS-1$
			mainHtmlMessage: '', //$NON-NLS-1$
			backgroundClass: 'relm-DialogHelpHeader-defaultBackground', //$NON-NLS-1$
			
			attributeMap: {
				mainHtmlMessage : {
					node : 'mainHtmlMessageNode', //$NON-NLS-1$
					type: "innerHTML" //$NON-NLS-1$
				}
			},

			postCreate: function() {
				this.inherited(arguments);
				
				if (this.mainMessage) {
					var textNode = document.createTextNode(this.mainMessage);
					this.mainMessageNode.appendChild(textNode);
				}
				else if (this.mainHtmlMessage) {
					this.mainMessageNode.innerHTML = this.mainHtmlMessage;
				}
			}
		}
	);

})();