dojo.provide('com.ibm.relm.ple.web.ui.TreeMenuFactory'); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.ple.web.ui', 'TreeMenuFactoryMessages'); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Pinning'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeSelection'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.MoveReusePlaceState'); //$NON-NLS-1$
dojo.require('jazz.ui.Menu'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.productedit.EditPropertiesDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.productedit.RenameProductDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.FreezeBranch'); //$NON-NLS-1$
dojo.require('relm.app.Permissions'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.StreamManagement'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.advanced.AdvancedSettings'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.pages.ReplaceBaselineDialog'); //$NON-NLS-1$

(function(){

var messages = dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui', 'TreeMenuFactoryMessages'); //$NON-NLS-1$ //$NON-NLS-2$

var productapi = com.ibm.relm.ple.web.ui.productapi;
var Pinning = com.ibm.relm.ple.web.ui.Pinning;
var TreeSelection = com.ibm.relm.ple.web.ui.TreeSelection;
var MoveReusePlaceState = com.ibm.relm.ple.web.ui.MoveReusePlaceState;
var FreezeBranch = com.ibm.relm.ple.web.ui.branch.FreezeBranch;
var Permissions = relm.app.Permissions;
var StreamManagement = com.ibm.relm.ple.web.rtc.StreamManagement;
var AdvancedSettings = com.ibm.relm.ple.web.advanced.AdvancedSettings;

// Start out as a flag saying this hasn't bee loaded yet.
var AnalysisUtil = false;

jazz.core.loader.load_async('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil', function() { //$NON-NLS-1$
	// Replace the flag with the actual object once loaded.
	AnalysisUtil = dojo.getObject('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil'); //$NON-NLS-1$
});

function createProductUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createProduct,
		iconClass: 'ple-icon-createProduct', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			productapi.createProduct(TreeSelection.getSelectedSite());
		}
	});
}

function addArtifactUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.addArtifactLink,
		disabled: disabled,
		iconClass: 'ple-icon-addArtifact', //$NON-NLS-1$
		onClick: function() {
			dojo.publish('ple.pick_artifact', [TreeSelection.getSelectedSite()]); //$NON-NLS-1$
		}
	});
}

function addUrlUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.addHyperlink,
		iconClass: 'ple-icon-addHyperlink', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			dojo.publish('ple.pick_hyperlink', [TreeSelection.getSelectedSite()]); //$NON-NLS-1$
		}
	});
}

/**
 * The Properties menu item shouldn't be shown for variability parameters, but
 * is shown as enabled otherwise (even on immutable products) so you can at
 * least see them (the dialog itself governs whether the Save button is
 * enabled). 
 */
function editProperties() {
	return new dijit.MenuItem({
		label: messages.editProperties,
		iconClass: 'ple-icon-edit', //$NON-NLS-1$
		onClick: function() {
			dojo.publish('ple.edit_properties'); //$NON-NLS-1$
		}
	});
}

function renameUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.rename,
		iconClass: 'ple-icon-rename', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var dialog = com.ibm.relm.ple.web.productedit.RenameProductDialog({
				itemVersion: TreeSelection.getSelectedSite().product
			});
			dialog.startup();
		}
	});
}

function compareWithLastSnapshot() {
	return new dijit.MenuItem({
		label: messages.compareWithLastSnapshot,
		iconClass: 'ple-icon-compareLastSnapshot', //$NON-NLS-1$
		onClick: function() {
			var item = TreeSelection.getSelectedSite().product;
			var productUri = TreeSelection.store.getValue(item, 'uri'); //$NON-NLS-1$
			dojo.publish('ple.compare', [productUri]); //$NON-NLS-1$
		}
	});
}

function showAuditHistory() {
	return new dijit.MenuItem({
		label: messages.showAuditHistory,
		iconClass: 'ple-icon-history', //$NON-NLS-1$
		onClick: function() {
			var item = TreeSelection.getSelectedSite().product;
			var productUri = TreeSelection.store.getValue(item, 'uri'); //$NON-NLS-1$
			dojo.publish('ple.history', [productUri]); //$NON-NLS-1$
		}
	});
}

function findUse() {
	return new dijit.MenuItem({
		label: messages.findUse,
		iconClass: 'ple-icon-findUse', //$NON-NLS-1$
		onClick: function() {
			var product = TreeSelection.getSelectedSite().product;
			dojo.publish('ple.find_parents', [product.uri]); //$NON-NLS-1$
		}
	});
}

function findArtifactUse() {
	return new dijit.MenuItem({
		label: messages.findUseInProducts,
		iconClass: 'ple-icon-findUse', //$NON-NLS-1$
		onClick: function() {
			var link = TreeSelection.getSelectedSite().link;
			dojo.publish('ple.find_artifact_parents', [link.uri, link.privateBaseline]); //$NON-NLS-1$
		}
	});
}

function checkOutUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.checkOut,
		iconClass: 'ple-icon-checkOut', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var selected = TreeSelection.getSelectedSite();
			productapi.checkOutProduct(selected.product, selected.parentProduct);
		}
	});
}

function createSnapshotUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createSnapshot,
		iconClass: 'ple-icon-createSnapshot', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var item = TreeSelection.getSelectedSite().product;
			var canFreeze = !item.rtcStream && !item.rtcComponent;
			var productUri = TreeSelection.store.getValue(item, 'uri'); //$NON-NLS-1$
			var productName = TreeSelection.store.getValue(item, 'name'); //$NON-NLS-1$
			var branchName = TreeSelection.store.getValue(item, '_branch_name');  //$NON-NLS-1$
			var branchUri = TreeSelection.store.getValue(item, 'pd:branch'); //$NON-NLS-1$
			dojo.publish('ple.create_snapshot', [productUri, productName, branchName, branchUri, canFreeze]); //$NON-NLS-1$
		}
	});
}

function addProductUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.addProduct,
		disabled: disabled,
		iconClass: 'ple-icon-addProduct', //$NON-NLS-1$
		onClick: function() {
			dojo.publish('ple.pick_product', [TreeSelection.getSelectedSite()]); //$NON-NLS-1$
		}
	});
}

function createBranchUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.createBranch,
		disabled: disabled,
		iconClass: 'ple-icon-createBranch', //$NON-NLS-1$
		onClick: function() {
			dojo.publish('ple.create_branch', [TreeSelection.getSelectedSite()]); //$NON-NLS-1$
		}
	});

}

function removeAnythingUnless(disabled) {
	var allSelected = TreeSelection.getAllSelectedSites();

	return new dijit.MenuItem({
		label: messages.removeProduct,
		iconClass: 'ple-icon-remove', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			dojo.publish('ple.remove_anything', [allSelected]); //$NON-NLS-1$
		}
	});

}

function replaceBranchUnless(disabled) {
	var selected = TreeSelection.getSelectedSite();

	return new dijit.MenuItem({
		label: messages.replaceBranch,
		iconClass: 'ple-icon-replaceBranch', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			dojo.publish('ple.use_branch', [selected]); //$NON-NLS-1$
		}
	});
}

function replaceSnapshotUnless(disabled) {
	var selected = TreeSelection.getSelectedSite();

	return new dijit.MenuItem({
		label: messages.replaceSnapshot,
		iconClass: 'ple-icon-replaceSnapshot', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			dojo.publish('ple.use_snapshot', [selected.parentProduct, selected.product]); //$NON-NLS-1$
		}
	});
}

function replaceBaselineUnless(disabled) {
	var selected = TreeSelection.getSelectedSite();

	return new dijit.MenuItem({
		label: messages.replaceBaseline,
		iconClass: 'ple-icon-replaceBaseline', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var d = new com.ibm.relm.ple.web.ui.pages.ReplaceBaselineDialog({
				site: selected
			});
			d.startup();
		}
	});
}


function unfreezeBranch() {
	var selectedSite = TreeSelection.getSelectedSite();
	var product = selectedSite.product;
	var productName = TreeSelection.store.getValue(product, 'name'); //$NON-NLS-1$
	var branchUri = TreeSelection.store.getValue(product, 'pd:branch'); //$NON-NLS-1$

	return new dijit.MenuItem({
		label: messages.unfreezeBranch,
		iconClass: 'ple-icon-unfreezeBranch', //$NON-NLS-1$
		onClick: function() {
			FreezeBranch.unfreeze(productName, branchUri);
		}
	});
}

function freezeBranchUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.freezeBranch,
		iconClass: 'ple-icon-freezeBranch', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			FreezeBranch.freezeSelectedBranch();
		}
	});
}

function moveUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.moveMenuLabel,
		iconClass: 'ple-icon-move', //'cut-enabled', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			MoveReusePlaceState.saveSelectionForMove();
		}
	});
}

function reuseUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.reuseMenuLabel,
		iconClass: 'ple-icon-reuse', //'copy-enabled' //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			MoveReusePlaceState.saveSelectionForReuse();
		}
	});
}

function placeUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.placeMenuLabel,
		iconClass: 'ple-icon-place', //'paste-enabled', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			MoveReusePlaceState.placeSavedSelection();
		}
	});
}

function openAnyLinkInNewWindow(menuItemLabel) {
	return new dijit.MenuItem({
		label: menuItemLabel,
		iconClass: 'ple-icon-artifactLink', //$NON-NLS-1$
		onClick: function() {
			var hyperlinkItem = TreeSelection.getSelectedSite().link;
			var url = TreeSelection.store.getValue(hyperlinkItem, 'link'); //$NON-NLS-1$
			window.open(url);
		}
	});
}

function openHyperlinkInNewWindow(argument) {
	return openAnyLinkInNewWindow(messages.openLinkInNewWindow);
}

function openArtifactInNewWindow(argument) {
	return openAnyLinkInNewWindow(messages.openArtifactInNewWindow);
}

function startAnalysis() {
	return new dijit.MenuItem({
		label: messages.startAnalysis,
		iconClass: 'ple-icon-impactAnalysis', //$NON-NLS-1$
		onClick: function() {
			var selected = TreeSelection.getSelectedSite();
			if (selected.link) {
				AnalysisUtil.createAnalysisForResource(selected.link.oslcConceptUri);
			}
			else {
				// It's a product
				AnalysisUtil.createAnalysisForResource(selected.product.uri);
			}
		}
	});
}

function exportUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.exportProduct,
		iconClass: 'ple-icon-download', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var selected = TreeSelection.getSelectedSite();
			productapi.exportProduct(selected.product);
		}
	});	
}

function unpinUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.unpin,
		iconClass: 'ple-icon-pinned', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var selected = TreeSelection.getSelectedSite();
			Pinning.unpinProduct(selected.parentProduct, selected.product);
		}
	});
}

function redactUnless(disabled) {
	return new dijit.MenuItem({
		label: messages.redactVersion,
		iconClass: 'ple-icon-redact', //$NON-NLS-1$
		disabled: disabled,
		onClick: function() {
			var selected = TreeSelection.getSelectedSite();
			var selectedArray = [selected.product];
			dojo.publish('ple.redact', [selectedArray]); //$NON-NLS-1$
		}
	});	
}

function newProductContextMenu() {
	var menu = new jazz.ui.Menu();
	dojo.addClass(menu.domNode, 'com-ibm-ple-ProductTree-menu'); //$NON-NLS-1$

	var selectedSite = TreeSelection.getSelectedSite();
	var itemVersion = selectedSite.product;
	var isConfiguration = itemVersion.conditionVariables !== undefined;
	var isChild =  !!selectedSite.parentProduct;
	var immutable = TreeSelection.store.getValue(itemVersion, 'pd:immutable'); //$NON-NLS-1$
	var pinned = TreeSelection.store.getValue(itemVersion, 'pd:pinned'); //$NON-NLS-1$
	var isPlaceReady = MoveReusePlaceState.isPlaceReady();
	var canModify = Permissions.canProductsModify();
	var canSnapshot = Permissions.canProductsCreateSnapshot();
	var canBranch = Permissions.canProductsBranch();
	var canAddProperty = Permissions.canProductsAddProperty();
	var canExport = !!AdvancedSettings.product_export;
	var canRedact = Permissions.canProductsRedact();

	var frozenTip = itemVersion["ple:isFrozenTip"]; //$NON-NLS-1$
	var frozenHierarchy = itemVersion["ple:isFrozenHierarchy"]; //$NON-NLS-1$
	var freezeDisabled = frozenTip || frozenHierarchy;

	if (!isConfiguration) {
		menu.addChild(createProductUnless(!canModify || freezeDisabled));
		menu.addChild(new dijit.MenuSeparator());
	}

	if (immutable) {
		menu.addChild(checkOutUnless(!canModify || freezeDisabled));
	} else {
		menu.addChild(createSnapshotUnless(!canSnapshot || freezeDisabled));
	}
	menu.addChild(createBranchUnless(!canBranch || frozenHierarchy));

	menu.addChild(new dijit.MenuSeparator());

	if (StreamManagement.enabled && !isConfiguration) {
		var submenuItem = new dijit.PopupMenuItem({
			label: messages.streamManagement, 
			popup: StreamManagement.createMenuForSelectedSites(),
			iconClass: 'ple-icon-rtc' //$NON-NLS-1$
		});

		menu.addChild(submenuItem);
		menu.addChild(new dijit.MenuSeparator());
	}

	if (!isConfiguration) {
		menu.addChild(addProductUnless(!canModify || freezeDisabled));
		menu.addChild(addArtifactUnless(!canAddProperty || freezeDisabled));
		menu.addChild(addUrlUnless(!canAddProperty || freezeDisabled));

		menu.addChild(new dijit.MenuSeparator());
	}

	pinned && menu.addChild(unpinUnless(!canModify || freezeDisabled));
	isChild && menu.addChild(replaceSnapshotUnless(!canModify || freezeDisabled));
	isChild && menu.addChild(replaceBranchUnless(!canModify || frozenHierarchy));
	menu.addChild(findUse());
	!!AnalysisUtil && menu.addChild(startAnalysis());

	var streamOrComponent = itemVersion.rtcStream || itemVersion.rtcComponent; 
	if (!streamOrComponent) {
		immutable && menu.addChild(new dijit.MenuSeparator());
		immutable && !frozenTip && menu.addChild(freezeBranchUnless(!canSnapshot || freezeDisabled));
		immutable && frozenTip && menu.addChild(unfreezeBranch(!canModify || freezeDisabled));
	}

	menu.addChild(new dijit.MenuSeparator());

	menu.addChild(showAuditHistory(freezeDisabled));
	menu.addChild(compareWithLastSnapshot(freezeDisabled));

	menu.addChild(new dijit.MenuSeparator());

	isChild && menu.addChild(moveUnless(!canModify || frozenHierarchy));
	menu.addChild(reuseUnless(!canModify));
	isPlaceReady && menu.addChild(placeUnless(!canModify || freezeDisabled));


	menu.addChild(new dijit.MenuSeparator());

	menu.addChild(removeAnythingUnless(!canModify || freezeDisabled));
	menu.addChild(renameUnless(!canModify || freezeDisabled));
	canExport && menu.addChild(exportUnless(!canModify));
	canRedact && menu.addChild(redactUnless());
	
	if (!isConfiguration) {
		menu.addChild(new dijit.MenuSeparator());
		menu.addChild(editProperties());
	}

	menu.startup();

	return menu;
}

function newArtifactContextMenu() {
	var canDeleteProperty = Permissions.canProductsDeleteProperty();
	var canModify = Permissions.canProductsModify();
	var isFrozenHierarchy = FreezeBranch.checkSelectedFrozenHierarchy();
	var artifact = TreeSelection.getSelectedSite().link;

	var menu = new jazz.ui.Menu();
	dojo.addClass(menu.domNode, 'com-ibm-ple-ProductTree-menu'); //$NON-NLS-1$

	menu.addChild(openArtifactInNewWindow());

	menu.addChild(new dijit.MenuSeparator());

	if (artifact.isDoorsBaseline) {
		menu.addChild(replaceBaselineUnless(!canModify));
	}
	menu.addChild(findArtifactUse());
	!!AnalysisUtil && menu.addChild(startAnalysis());

	menu.addChild(new dijit.MenuSeparator());
	menu.addChild(moveUnless(!canModify || isFrozenHierarchy));
	menu.addChild(reuseUnless(!canModify));

	menu.addChild(new dijit.MenuSeparator());
	menu.addChild(removeAnythingUnless(!canDeleteProperty || isFrozenHierarchy));

	menu.startup();

	return menu;
}

/**
 * Factory to create new dijit.Menus pre-populated with the proper menu items
 * for the currently selected item in the tree. Can be used from the page level toolbar
 * or the tree itself.
 */
dojo.mixin(com.ibm.relm.ple.web.ui.TreeMenuFactory, {

	/**
	 * Returns a brand new dijit.Menu. The caller must destroy this when done.
	 * The menu items will be linked to the currently selected items or items
	 * in the TreeSelection.
	 *
	 * @return {dojo.Menu}            [description]
	 */
	newContextMenuForSelected: function () {
		var type = TreeSelection.getSelectedType();

		switch (type) {
		case 'product': //$NON-NLS-1$
			return newProductContextMenu();

		case 'link': //$NON-NLS-1$
			return newArtifactContextMenu();

		default:
			throw new Error('Unknown type in tree: ' + type); //$NON-NLS-1$
		}
	}

});

})();