/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.ui.branch.DimensionValueRow'); //$NON-NLS-1$

dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.ple.web.ui.branch', 'DimensionItemMessages'); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require('com.ibm.relm.ple.web.ui.branch.StatefulRow'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch._ForceWatchCallbacksMixin'); //$NON-NLS-1$

(function(){

	/**
	 * A wrapper around a StatefulRow that is the UI for editing a dimension value.
	 */
	dojo.declare(
		'com.ibm.relm.ple.web.ui.branch.DimensionValueRow', //$NON-NLS-1$
		[ jazz.ui.tree.AbstractItem, dijit._Widget ],
		{
			messages: dojo.i18n.getLocalization('com.ibm.relm.ple.web.ui.branch', 'DimensionItemMessages'), //$NON-NLS-1$ //$NON-NLS-2$

			model: null,

			buildRendering: function() {
				this.domNode = dojo.create('li'); //$NON-NLS-1$

				this.stateful = new com.ibm.relm.ple.web.ui.branch.StatefulRow({
					model: this.model,
					shouldRemoveStatefulRow: this.shouldRemoveStatefulRow
				});
				this.stateful.placeAt(this.domNode);
			},

			postCreate: function() {
				this.connect(this.domNode, 'ondblclick', function() { //$NON-NLS-1$
					this.stateful.rename();
				});

			},

			rename: function() {
				this.stateful.rename();
			},

			uninitialize: function() {
				this.stateful.destroyRecursive();
			}
		}
	);
})();