/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.editor.SectionDialog"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojox.gfx"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.editor.sections.Connection"); //$NON-NLS-1$

(function() {
	
com.ibm.relm.explorer.web.ui.internal.editor.SectionDialog = {
	openGeneralDialog: function(editor, dummy, okCallback){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.General({_configEditor: editor});
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelGeneral, okCallback);
	},

	openQueryDialog: function(editor, selectedIndex, okCallback){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.Query({_configEditor: editor});
		if(selectedIndex >= 0) sectionWidget.setSelectedIndex(selectedIndex);
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelQuery, okCallback);
		if(selectedIndex < 0) sectionWidget.setSelectedIndex(selectedIndex);
	},

	openResourceDialog: function(editor, resInfoOrIndex, okCallback){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.Resource({_configEditor: editor});
		if(isNaN(resInfoOrIndex)){
			sectionWidget.setSelected({resourceInfo: resInfoOrIndex});
		}else{
			sectionWidget.setSelectedIndex(resInfoOrIndex);
		}
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelResource, okCallback);
	},
	
	openConnectionDialog: function(editor, selectedIndex, okCallback){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.Connection({_configEditor: editor});
		sectionWidget.setSelectedIndex(selectedIndex);
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelConnection, okCallback);
	},

	openBackgroundDialog: function(editor, dummy, okCallback){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.Background({_configEditor: editor});
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelBackground, okCallback);
	},

	openComponentInfoDialog: function(editor, dummy, okCallback){
		var sectionWidget = new com.ibm.relm.explorer.web.ui.internal.editor.sections.ComponentInfo({_configEditor: editor});
		openSectionDialog(sectionWidget, sectionWidget.messages.LabelComponentInfo, okCallback);
	}

};
	
var openSectionDialog = function(sectionWidget, title, okCallback){
	var content = new dijit.layout.ContentPane();
    dojo.style(content.domNode, {
        "maxHeight": "480px", //$NON-NLS-1$ //$NON-NLS-2$
        "overflow": "auto" //$NON-NLS-1$ //$NON-NLS-2$
    });
	content.set("content", sectionWidget); //$NON-NLS-1$

	// show dialog
	new com.ibm.relm.explorer.web.ui.internal.view.common.ButtonDialog({
		dialogContent: content,
		primaryTitle: title,
		width: "", //$NON-NLS-1$
		onOpen: function(){
//			dijit.focus(contentWidget.shapeLabelField);
		},
		validate: function(values, callback){
			if(sectionWidget.validate && !sectionWidget.validate(values)) {
				return;
			}
			callback();
		},
		onOK: function(values){
			okCallback();
		}
	});
};

})();