/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.editor.sections._SectionMixin"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.TableUtils"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ConfigFormEditorMessages"); //$NON-NLS-1$  //$NON-NLS-2$

var CLASS_ADD_COMMAND = "add-command"; //$NON-NLS-1$

var tableUtils = com.ibm.relm.explorer.web.ui.internal.view.common.TableUtils;

dojo.declare("com.ibm.relm.explorer.web.ui.internal.editor.sections._SectionMixin", null, { //$NON-NLS-1$
	_configEditor : null,
	
	setConfigEditor: function(editor){
		this._configEditor = editor;
	},
	
	getConfigEditor: function(){
		return this._configEditor;
	},
	
	getConfig: function(){
		return this._configEditor.getConfig();
	},
	
	_updateDirty: function(oldvalue, newvalue, propName){
		return this._configEditor._updateDirty(oldvalue, newvalue, propName);
	},
	
	getDiagramEditor: function(){
		return this._configEditor.getDiagramEditor();
	},
	
	_createAddButton: function(label, callback, context, buttonLabel){
		callback = dojo.hitch(context || this, callback);
		return dojo.create("a", {  //$NON-NLS-1$
			href: "#",  //$NON-NLS-1$
			innerHTML: buttonLabel || messages.Add,
			className: CLASS_ADD_COMMAND,
			title: label,
			style: {
				verticalAlign: "middle",  //$NON-NLS-1$
				marginLeft: "8px"  //$NON-NLS-1$
			},
			onclick: function(e){
				dojo.stopEvent(e);
				callback();
			}
		});
	},

	_createParamTableColumnsEx: tableUtils.createParamTableColumnsEx,
	_createNameValueTableColumns: tableUtils.createNameValueTableColumns,
	_createTableColumns: tableUtils.createTableColumns, 
	_createTableColumnDescription: tableUtils.createTableColumnDescription
	
});


})();
