/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.hover._GfxRichHoverMixin"); //$NON-NLS-1$
dojo.require("dojox.gfx.shape"); //$NON-NLS-1$

(function(){

dojo.declare("com.ibm.relm.explorer.web.ui.internal.hover._GfxRichHoverMixin", null, { //$NON-NLS-1$
	_htmlNode: null,
	
	position: function(node){
		if(!this._htmlNode){
			var par = this.owner;
			while(!par.isEditor) par = par.getParent(); // find com.ibm.relm.explorer.web.base.internal.canvas.Viewer
			this._htmlNode = dojo.create("div", {style: {position: "absolute"}}, par.domNode); //$NON-NLS-1$ //$NON-NLS-2$
		}
		var l=Number.MAX_VALUE, t=Number.MAX_VALUE, w=0, h=0;
		var shape = this.shape;
		if(shape instanceof dojox.gfx.Group){
			dojo.forEach(shape.children, function(childShape){
				var s = childShape.shape; 
				if(s.type == "polyline" && s.points && s.points.length > 2){ //$NON-NLS-1$
					var targetPoint = s.points[s.points.length/2-1]; // middle point
					var targetPoint2 = s.points[s.points.length/2]; // middle point 2
					var dx = Math.abs(targetPoint.x - targetPoint2.x);
					var dy = Math.abs(targetPoint.y - targetPoint2.y);
					w = h = 10;
					if(dx < w || dy < h){
						l = Math.min(targetPoint.x, targetPoint2.x);
						t = Math.min(targetPoint.y, targetPoint2.y);
						if(dx  < w){
							// vertical line
	 						h = dy;							
						} else {
							// horizontal line
	 						w = dx;														
						}
					} else {
						// use a point
						l = targetPoint.x - w/2;
						t = targetPoint.y - h/2;
					}
					var m = childShape._getRealMatrix();
					var gm = dojox.gfx.matrix;
					var topLeft = gm.multiplyPoint(m, l, t);
					l = topLeft.x;
					t = topLeft.y;
					return;
				}
				var boxes = childShape.getTransformedBoundingBox();
				if(boxes){ // boxes is null for Text shape
					var topLeft = boxes[0]; // top-left corner
					var bottomRight = boxes[2]; // bottom-right corner
					if(s.type == "path"){ //$NON-NLS-1$
						// round connection
						l = (topLeft.x + bottomRight.x)/2;
						t = (topLeft.y + bottomRight.y)/2;
					}else{
						l = Math.min(l, topLeft.x);
						t = Math.min(t, topLeft.y);
						w = Math.max(w, bottomRight.x-topLeft.x);
						h = Math.max(h, bottomRight.y-topLeft.y);
					}
				}
			});
		}else{
			var boxes = shape.getTransformedBoundingBox();
			var topLeft = boxes[0]; // top-left corner
			var bottomRight = boxes[2]; // bottom-right corner
			l = topLeft.x, 
			t = topLeft.y;
			w = bottomRight.x-topLeft.x, 
			h = bottomRight.y-topLeft.y;
		}
		var aroundNode = this._htmlNode;
		dojo.style(aroundNode, {
			display: "", //$NON-NLS-1$
			left: l+"px", //$NON-NLS-1$
			top: t+"px", //$NON-NLS-1$
			width: w+"px", //$NON-NLS-1$
			height: h+"px" //$NON-NLS-1$
		});
	
		this.inherited(arguments, [aroundNode]);

		aroundNode.style.display = "none"; //$NON-NLS-1$
	}
});

})();