/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.relm.explorer.web.ui.internal.list.ViewRow"); //$NON-NLS-1$

dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal.list", "ViewRowMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require("com.ibm.relm.explorer.web.ui.internal.list.ListRow"); //$NON-NLS-1$

(function() {

	var VIEWTYPE = "view"; //$NON-NLS-1$
	var VIEW_ICON = dojo.moduleUrl("com.ibm.relm.explorer.web", "ui/images/view.gif"); //$NON-NLS-1$ //$NON-NLS-2$

	dojo.declare(
		"com.ibm.relm.explorer.web.ui.internal.list.ViewRow", //$NON-NLS-1$
		[com.ibm.relm.explorer.web.ui.internal.list.ListRow],
		{
			templatePath: dojo.moduleUrl('com.ibm.relm.explorer.web','ui/internal/list/templates/ViewRow.html'), //$NON-NLS-1$ //$NON-NLS-2$
			widgetsInTemplate: false,
			messages: dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal.list", "ViewRowMessages"), //$NON-NLS-1$ //$NON-NLS-2$
			
			constructor: function(args, node) {
				this._handleViewCheckBoxClick = args._handleViewCheckBoxClick;
				
				this.guid = this.item.name.value;
				this.rowType = VIEWTYPE;
				this.folderID = this.item.parentUUID; //Save this so we can find the folder row easily
				this.iconSrc = VIEW_ICON;
			},

			postCreate: function() {
				this.inherited(arguments);
				this._formatResource(this.item.name, this.viewName, this.item);
				this.domNode.folderID = this.folderID;
			}
		});
	})();