/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.common.ViewSelect"); //$NON-NLS-1$

dojo.require("dijit.form.ComboBox");//$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.util");//$NON-NLS-1$
dojo.require("dojo.store.Memory");//$NON-NLS-1$

(function()  {

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.common.ViewSelect", //$NON-NLS-1$
	dijit.form.ComboBox,
{
	// possible attr names are "title", "viewid", "uri" 
	// labelAttr is used for labels in dropdown list
	// searchAttr is used for text in text box and value
	labelAttr: "title", //$NON-NLS-1$
	searchAttr: "viewid", //$NON-NLS-1$
	
	defaultEntry: null,
	
	getTitle: function(){
		return  this.item ? this.item.title : null;
	},
	
	getId: function(){
		return  this.item ? this.item.viewid : null;
	},
	
	getUri: function(){
		return  this.item ? this.item.uri : null;
	},
	
	// not used now. need use FilteringSelect instead of ComboBox
	valueAttr: "viewid", //$NON-NLS-1$
	
	_views: null,

	postCreate: function(){
		this.inherited(arguments);
		var context = jazz.app.context.get();
		this._populateViews(context && context.itemId);
	},
	
	setProjectArea: function(projectAreaUUID){
		this._populateViews(projectAreaUUID);
	},
	
	_populateViews: function(projectAreaUUID){
		var self = this;
		self._views = [];
		jazz.client.xhrGet({
			url: com.ibm.relm.explorer.web.ui.configServiceUri+"?allconfig", //$NON-NLS-1$ 
			content: {
				projectAreaUUID: projectAreaUUID || "" //$NON-NLS-1$
			},
			load: function(response, ioArgs){
				var templates = response.results.bindings;
				if(templates && templates.length > 0) {
					dojo.forEach(templates, function(t){
						self._views.push({title: t.title.value, viewid: t.viewid.value, uri: t.uri.value});
					});
				}
			},
			handle: function(){
				if(self.defaultEntry){
					self._views.unshift(self.defaultEntry);
				}
				var tmplStore = new dojo.store.Memory({
					data: self._views,
					idProperty: self.valueAttr
				});
				self.set("store",tmplStore); //$NON-NLS-1$
			},
			handleAs: "json" //$NON-NLS-1$
		});
	}
});

}) ();