/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.edit.EditCommand"); //$NON-NLS-1$

// ----------------------------------------------------------------------------
// Command classes which encapsulate a request as an object
// ----------------------------------------------------------------------------

com.ibm.relm.explorer.web.ui.internal.view.edit.EditCommand = {
	UpdateCommand: function(widget){
		this._widget = widget;

		this.execute = function(){
			var widget = this._widget;
			if(dojo.isFunction(widget.hlp_getEditor)){
				var editor = widget.hlp_getEditor();
//				editor.removeFocusFrame(widget); // children might hold the focus now. remove it.
				if(widget.setup) {
					widget.setup(true);
				}
				for(var n = widget; n; n =  n.getParent()){
					if(dojo.isFunction(n.layout)){
						n.layout();
					}
					if(!dojo.isFunction(n.getParent)) break;
				}
				editor.fireLoadResource(); // for reload connections
				widget.update();
			}	
		};
		this.undo = this.execute;
	}
};
