/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.extensions.queryCache"); //$NON-NLS-1$

(function(){

com.ibm.relm.explorer.web.ui.internal.view.extensions.queryCache = {
	_getCachedResult: function(query, parameterValues){
		var editor = this.hlp_getEditor();
		if(!editor || !editor._cachedQueries){
			return null;
		}
		var cache = editor._cachedQueries;
		for(var i=cache.length-1; i>=0; i--){
			var c = cache[i];
			if(c.query === query && c.parameterValues === dojo.toJson(parameterValues||null)){
				return c.result;					
			}
		};
		return null;
	},
	
	_addCachedResult: function(query, parameterValues, result){
		var editor = this.hlp_getEditor();
		if(!editor || !editor._editMode){
			return null;
		}
		if(!editor._cachedQueries){
			editor._cachedQueries = [];
		}
		editor._cachedQueries.push({query:query, parameterValues: dojo.toJson(parameterValues||null), result:result});
	}

};

})();
