/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes._ActionsMixin"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.Rect"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.base.internal.gdc.Image"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.xmlutils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.ConfigUtils"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.Workbench"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.hover.GfxRichHover"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.policies.OutlineRenderer"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.layout.DefaultLayout"); //$NON-NLS-1$
dojo.require("jazz.app.ua.internal.HelpDOMNode");//$NON-NLS-1$

dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "NodesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){
	
var utils = com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeUtils;
var configUtils = com.ibm.relm.explorer.web.ui.internal.ConfigUtils;
var xmlutils = com.ibm.relm.explorer.web.ui.internal.xmlutils;
var errorIconURL = dojo.moduleUrl("com.ibm.relm.explorer.web","ui/internal/view/images/error.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var infoIconURL = dojo.moduleUrl("com.ibm.relm.explorer.web","ui/internal/view/images/page-help-hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
var loadingIconURL = dojo.moduleUrl("com.ibm.relm.explorer.web","ui/internal/view/images/loading.gif"); //$NON-NLS-1$ //$NON-NLS-2$

var ICONCLASS_QUERY = "query-icon"; //$NON-NLS-1$
var ICONCLASS_DELETE = "delete-icon"; //$NON-NLS-1$

dojo.declare(
	"com.ibm.relm.explorer.web.ui.internal.view.nodes.NodeContainer", //$NON-NLS-1$
	[com.ibm.relm.explorer.web.base.internal.gdc.Rect, com.ibm.relm.explorer.web.ui.internal.view.nodes._ActionsMixin],
{
	_domNode: null,
	_viewer: null,
	_queryParams: null,
	containerParams: null,
	_layoutManager: null,
	_params: [],
	_specifiedDimension: {},
	_containerId: "", //$NON-NLS-1$
	fill: "", // override Rect's default value = "white" //$NON-NLS-1$
	stroke: "", // don't show border //$NON-NLS-1$

	// attributes setter
	setBaseQueryId: function(queryId){
		this._query = null;
		this.queryTemplate = null;
		this.baseQueryId = queryId;
	},
	
	setQueryParams: function(params){
		this._queryParams = (params || "").split(",");//$NON-NLS-1$ //$NON-NLS-2$
		this._query = null;
	},
	
	setId: function(id) {
		this._containerId = id;
	},
	
	setWidth: function(width){
		this.inherited(arguments);
		if(this._getEditMode()){
			this._specifiedDimension.width = width; 
		}
	},
	
	setHeight: function(height){
		this.inherited(arguments);
		if(this._getEditMode()){
			this._specifiedDimension.height = height; 
		}
	},
	
	// attributes getter
	getLayout: function(){
		return this.layoutManager || (this._domNode && this._domNode.getAttribute("layout")); //$NON-NLS-1$
	},
	
	getVspacing: function(){
		return this.vspacing || this.spacing || this._layoutManager.defaultSpacing;
	},
	
	getHspacing: function(){
		return this.hspacing || this.spacing || this._layoutManager.defaultSpacing;
	},
	
	getId: function(){
		if(this._containerId == "") { //$NON-NLS-1$
			if(this._domNode) {
				this._containerId  = this._domNode.getAttribute("id") || ""; //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
		
		return this._containerId; 
	},
	
	getQueryParams: function(){
		return (this._queryParams || []).join(",");//$NON-NLS-1$
	},
	
	//
	postCreate: function(){
		this.inherited(arguments);

		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "NodesMessages");		 //$NON-NLS-1$ //$NON-NLS-2$

		var domNode = this._domNode;
		if(domNode){
			if(this.showGrid) this.showGrid = xmlutils.getBooleanValue(this.showGrid);
			if(this.pack) this.pack = xmlutils.getBooleanValue(this.pack);
			if(this.allowOverwrap) this.allowOverwrap = xmlutils.getBooleanValue(this.allowOverwrap);
			if(this.expandChild) this.expandChild = xmlutils.getBooleanValue(this.expandChild);
			
			this._specifiedDimension = {width: domNode.getAttribute("width"), height: domNode.getAttribute("height")}; //$NON-NLS-1$ //$NON-NLS-2$
			this.setLeft(this.x || this.left || 0);
			this.setTop(this.y || this.top || 0);
			this.setWidth(this.width || 0); // IE
			this.setHeight(this.height || 0); // IE
			
			if(!this.baseQueryId && this._viewer.config._defaultQueryId){
				// see Config#_migrate10()
				this.baseQueryId = this._viewer.config._defaultQueryId;
			}
			
			var qp = domNode.getAttribute("queryParams"); //$NON-NLS-1$
			if(qp !== null){
				this._queryParams = (qp || "").split(","); //$NON-NLS-1$ //$NON-NLS-2$
			}
			
			this._params = this._getParams();
			
			this._viewer.addContainer(this);
		}else{
			this._specifiedDimension = {width: this.width, height: this.height}; // drag and drop from palette 			
		}

		this.setLayoutManager(this.getLayoutManager());
		this.createPolicies();
	},
	
	uninitialize: function() {
		this.destroyDescendants();
		this.inherited(arguments);
		this._viewer.removeContainer(this.id);		
		if(this._helpNode) this._helpNode.destroy();
		if(this.hover) this.hover.destroy();
	},
	
	addChild: function(/*dijit/_WidgetBase*/ widget, /*int?*/ insertIndex){
		if(this._infoIcon && widget != this._infoIcon){
			if(this._infoIcon == this.iconNode){
				this._removeIcon();
			}else 
			if(this._infoIcon.domNode){
				this._infoIcon.destroy();
			}
			this._infoIcon = null;
		}
		this.inherited(arguments);		
	},
	
	update: function(props){
		this.inherited(arguments);
	},

	createPolicies: function() {
//		this.createPolicy(com.ibm.relm.explorer.web.ui.internal.view.policies.OutlineRenderer);
	},
	
	_getParams: function(){
		
		return utils.getParamValue(this.getParameters());
	},
	
	getParameters: function() {
		var self = this;
		if(!self.containerParams) {
			self.containerParams = {};
			if(self._domNode) {
				dojo.forEach(xmlutils.getChildNodesByName("param", self._domNode), function(param){ //$NON-NLS-1$
					var value = param.getAttribute("value");  //$NON-NLS-1$
					var desc = param.getAttribute("description");  //$NON-NLS-1$
					self.containerParams[param.getAttribute("name")] = {value: value, description: desc};  //$NON-NLS-1$
				});
			}
		}
		return this.containerParams;
	},
	
	setParameters: function(params) {
		this.containerParams = params;
		this._params = this._getParams(); // update _params
		this._query = null; // clear evaluated query 
	},
	
	showContextMenu: function(x, y) {
		if (x && y) {
			this.inherited(arguments);
		}
		else {
			// XXX: assumes there is a _viewer property to find the top shape layer.
			var pos = utils.shapePosition(this.shape, this._viewer);
			x = pos.x;
			y = pos.y;

			// Normally an unpositioned menu pops up below the node, but since
			// NodeConatiners are very tall, this can push the menu off the
			// page. It's better to first the menu to be at the top of the
			// container.
			this.inherited(arguments, [x, y]);
		}
	},

	_getAllActions: function() {
		var self = this;
		var actions = [];
		if(this.getQuery(true)){
			actions.push({
				nodeWidget: this,
				actionType: 'showQuery', //$NON-NLS-1$
				label: self.messages.showQuery,
				iconClass: ICONCLASS_QUERY,
				action: function(){
					if(self._getEditMode()) {
						if(!confirm(self.messages.confirmExecuteAction)) return; 	
					}
					self.openQueryEditor();
				}
			});
		}
		if(this._getEditMode()) {
			actions.push(		{
				nodeWidget: this,
				actionType: 'custom', //$NON-NLS-1$
				label: self.messages.removeContainer,
				iconClass: ICONCLASS_DELETE,
				action: function(){
					self.removeContainer();
				}
			}
			);
		}

		return actions;
	},
	
	createTargetShape: function(){
		var shape = this.inherited(arguments);
		
		var self = this;
		this._createActionBar([
			{
				src: dojo.moduleUrl("relm.app", "graphics/icons/view_menu.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title: this.messages.menu,
				width: 16,
				onclick: function(iconShape){
					var pos = utils.shapePosition(iconShape, self._viewer);
					self.showContextMenu(pos.x, pos.y + pos.h);
				}
			}
		]);
		
		return shape;
	},

	openQueryEditor: function(){
		var self = this;
		window.location = "#action=jazz.viewPage&id=com.ibm.relm.explorer.web.ui.page.QueryPage"; //$NON-NLS-1$ 
		net.jazz.ajax.ui.PlatformUI.getWorkbench().viewPage("com.ibm.relm.explorer.web.ui.page.QueryPage",	function(){ //$NON-NLS-1$
			var query = self.getQuery(true);
			if(query && query.sparql){
				var qinfo = {sparql: query.sparql};
				if(query.parameterValues){
					qinfo.parameterValues = query.parameterValues;
					qinfo.parameterized = "true";//$NON-NLS-1$
				}
				setTimeout(function(){dojo.publish("EXECUTE_QUERY", [qinfo]);},1000);	//$NON-NLS-1$
			}
		});		
	},
	
	removeContainer: function() {
		var self = this;
		var containerId = self.getId();
		if(confirm(dojo.string.substitute(self.messages.confirmRemoveContainer, [containerId]))){
			var message = {
				type: "ActionInvokedNotification", //$NON-NLS-1$
				src: self,
				command: "del", //$NON-NLS-1$
				arg: null
			};
			dojo.publish("btp:ActionInvoked", [message]); //$NON-NLS-1$
		}

	},
	
	_getQueryFromTemplate: function(template, useClientSideStringTemplate){
		var baseQuery = template.sparql;				
		// replace %s in base query
		dojo.forEach(this._queryParams || [], function(param){
			baseQuery = baseQuery.replace("%s", param); //$NON-NLS-1$
		});
		// replace by params defined in 1. <container> 2. <view> 3. <queryTemplate> 
		var configParams = utils.getParamValue(this._viewer.config.params);
		var queryParams = utils.getParamValue(template.params);
		var paramArray = [this._params, configParams, queryParams];
		baseQuery = configUtils.evalParamsArray(baseQuery, paramArray, null, !useClientSideStringTemplate);
		if(baseQuery.indexOf("%s") >= 0){ //$NON-NLS-1$
			baseQuery = null;
		}
		var parameters = configUtils.getParameterValuesFromParamArray(paramArray);
		return {sparql: baseQuery, parameterValues: parameters};
		
	},
	
	getQuery: function(useClientSideStringTemplate){
		if(useClientSideStringTemplate){
			if(!this.queryTemplate){
				this.queryTemplate = this._viewer.config.getQueryTemplate(this.baseQueryId);
				if(!this.queryTemplate){
					return null;
				}
			}
			return this._getQueryFromTemplate(this.queryTemplate, true);
		}
		if(!this._query){
			if(!this.queryTemplate){
				this.queryTemplate = this._viewer.config.getQueryTemplate(this.baseQueryId);
			}
			if(this.queryTemplate){
				// sparql might be null ... e.g. %s is not resolved
				this._query = this._getQueryFromTemplate(this.queryTemplate);
			}
		}
		return this._query;
	},
	
	setQueryTemplate: function(queryTemplate){
		this.queryTemplate = queryTemplate;
	},
	
	getQueries: function(){		
		if(dojo.isArray(this.queryTemplates)){
			var self = this;
			return dojo.map(this.queryTemplates, function(template){
				return dojo.mixin({component: template.component}, self._getQueryFromTemplate(template));
			});
		}
		return null;
	},
	
	setQueryTemplates: function(queryTemplates){
		this.queryTemplates = queryTemplates;
		if(dojo.isArray(queryTemplates)){
			this.queryTemplate = queryTemplates[0];
		}
	},
	
	setLayoutManager: function(l){
		if(l){
			l._container = this;
		}
		this._layoutManager = l;
	},
	
	setup: function(keepChildren){
		if(!this._layoutManager){
			return;
		}
		this._removeIcon();
		
		this._layoutManager.setup(keepChildren);
		
		if(!this.hasChildren() && !this._query && this._getEditMode() && !this.preventSave){
			if(!this._helpNode){
				var parms = {uaKey: "com.ibm.relm.explorer.web.text_Views_Containers001"};//$NON-NLS-1$
				this._helpNode = new jazz.app.ua.internal.HelpDOMNode(parms);
			}
			this.showIcon(infoIconURL, null, this._helpNode);
			this._infoIcon = this.iconNode;
		}
	},
	
	layout: function(){
		this._layoutRequest = null;
		if(!this._layoutManager || this.iconNode){
			return;
		}

		dojo.forEach(this.getChildren(), function(c){ 
			if(dojo.isFunction(c.setLayoutReady)) c.setLayoutReady(true); 
		});

		this._layoutManager.layout();

		dojo.forEach(this.getChildren(), function(c){ 
			if(dojo.isFunction(c.setLayouted)) c.setLayouted(); 
		});
		dojo.publish("com.ibm.relm.explorer.web.CONTAINER_LAYOUT_COMPLETED"); //$NON-NLS-1$
	},
	
	_layoutRequest: null,
	requestLayout: function(delayedTime){
		if(this._layoutRequest){
			clearTimeout(this._layoutRequest);
		}
		this._layoutRequest = setTimeout(dojo.hitch(this, this.layout), !isNaN(delayedTime) ? delayedTime : 10);
	},
	
	reload: function(params){
		if(params){
			dojo.safeMixin(this._params, params);
			this._query = null;
		}
		this.setup();
		this.layout();
	},
	
	nodeMoved: function(/*Widget*/widget){
		dojo.forEach(this.getChildren(), function(w){
			if(w.nodeMoved) {
				w.nodeMoved();
			}
		});
		if(this._viewer)
			this._viewer.nodeMoved(this);
	},

	showIcon: function(iconUrl, message, helpBox){
		if(iconUrl){
			if(!this.iconNode || this.iconNode.src != iconUrl){
				this._removeIcon();
				this.iconNode = this._viewer.createComponent("image", {src: iconUrl, left: 0, top: 0, preventSave: true, movable: false}); //$NON-NLS-1$
				this.addChild(this.iconNode);
				if(this.hover) {
					this.hover.destroy();
					this.hover = null;
				}
				if(helpBox){
					this.hover = utils._createRichHover(this.iconNode, function(){
						return helpBox.domNode;
					});
				}else if(message){
					var summary = message.summary;
					this.hover = utils._createRichHover(this.iconNode, function(){
						var div = dojo.create("div"); //$NON-NLS-1$
						var content = summary;
						var detail = message.details && message.details.length > 0 && message.details[0].message;
						if(detail){
							content += "<div>" + detail + "</div>"; //$NON-NLS-1$ //$NON-NLS-2$
						}
						div.innerHTML = content;
						return div;
					});
				}
			}
		}else{
			this._removeIcon();
		}
	},
	
	_removeIcon: function(){
		if(this.iconNode){
			this.removeChild(this.iconNode);
			this.iconNode.destroy();
			delete this.iconNode;
			delete this._infoIcon;
		}		
	},
	
	setLoading: function(loading){
		if(loading){
			this.showIcon(loadingIconURL);
		}else{
			this.showIcon();
		}
	},
	
	setError: function(error, message){
		if(error){
			this.showIcon(errorIconURL, message);
		}else{
			this.showIcon();
		}
	},
	
	/*
	 * links is static links from/to all resource nodes in this container. Usually only tree container uses this attribute. 
	 */
	_links: {},
	setLinks: function(links){
		this._links = links;
	},
	
	getLinks: function(){
		return this._links;
	},
	
	getLayoutManager: function(){
		var layoutType = this.getLayout();
		if(layoutType){
			if(layoutType.indexOf('.') < 0){ //$NON-NLS-1$
				layoutType = "com.ibm.relm.explorer.web.ui.internal.view.layout." + layoutType; //$NON-NLS-1$
			}
			try {
	    		dojo.require(layoutType);
	    		var ctor = dojo.getObject(layoutType);
	    		if(ctor){
	    			return new ctor();
	    		}					
			}catch(e){
				console.error(e);
			}
		}
		return new com.ibm.relm.explorer.web.ui.internal.view.layout.DefaultLayout();
	},
	
	getOutputTagName: function(){
		return this.componentInfoId;
	},
	
	editModeChanged: function(editMode){
		if(this.shape){
			if(!this.getFill()){
				if(editMode){
					this.shape.setFill([255, 255, 255, 0.1]); 
				}else{
					this.shape.setFill(""); //$NON-NLS-1$
				}
			}
			if(!this.getStroke()){
				if(editMode){
					this.shape.setStroke({color: "#aaaaaa", style: "ShortDot"}); //$NON-NLS-1$ //$NON-NLS-2$
				}else{
					this.shape.setStroke(""); //$NON-NLS-1$
				}
			}
		}		
	},
	
	/*
	 * Called when drag and drop in View
	 * see DragMoveTracker.onDragEnd
	 */
	componentMoveHandler: function(e, tool, movedWidget){
		if(!this._getEditMode()) 
			return false;
		var lm = this._layoutManager; 
		if(lm && lm.componentMoveHandler){
			lm.componentMoveHandler(e, tool, movedWidget);
			return true;
		}
		return false;
	},
	
	/*
	 * Called when drag and drop from palette.
	 * see DefaultCreatetionTool.handleDrop
	 */
	componentDropHandler: function(e, tool){
		var lm = this._layoutManager; 
		if(lm && lm.componentDropHandler){
			lm.componentDropHandler(e, tool);
			return true;
		}
		return false;
	},
	
	getCaretRect: function(e){
		var lm = this._layoutManager; 
		if(lm && lm.getCaretRect){
			return lm.getCaretRect(e);
		}
		return null;
	},
	
	destroyQueryResultChildren: function(){
		dojo.forEach(this.getChildren(), function(widget){
			if(widget.preventSave && widget.destroyRecursive){
				widget.destroyRecursive();
			}
		}); 
	},
	
	_getEditMode: function(){
		if(this.hlp_getEditor){
			return this.hlp_getEditor()._editMode;
		}
		return false;
	}
});

})();