/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.ui.internal.views.ProductView'); //$NON-NLS-1$

dojo.require('dijit._Templated'); //$NON-NLS-1$
dojo.require('dijit._Widget'); //$NON-NLS-1$
dojo.require('dojo.date.locale'); //$NON-NLS-1$
dojo.require('dojo.i18n'); //$NON-NLS-1$
dojo.requireLocalization('com.ibm.relm.ple.web.ui.internal.views', 'ProductViewMessages'); //$NON-NLS-1$ //$NON-NLS-2$

dojo.require('net.jazz.ajax.ui.PlatformUI'); //$NON-NLS-1$

dojo.require('jazz.ui.StyledTable'); //$NON-NLS-1$
dojo.require('jazz.ui.PageTemplate'); //$NON-NLS-1$
dojo.require('jazz.ui.Dialog'); //$NON-NLS-1$
dojo.require('jazz.util.html'); //$NON-NLS-1$

dojo.require('com.ibm.relm.common.web.ui.AutoHeightBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.EasyMessageBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.FloatingMessageBox'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.LoadingMessage'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.Section'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ui.util'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.audit.ProductAudit'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.EditBranchDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.prop.UserPropertyTable'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.productedit.EditPropertiesDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.prop.PropertyName'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.productedit.RenameProductDialog'); //$NON-NLS-1$
dojo.require('jazz.ui.Toolbar'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.Button'); //$NON-NLS-1$
dojo.require('jazz.ui.toolbar.Separator'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.productapi'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.Goto'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.tree.TreeRefresh'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.TreeSelection'); //$NON-NLS-1$
dojo.require('relm.app.Permissions'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.branch.FreezeBranch'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.ResourceLinkBatchLoader'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.variability.EditConditionsDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.common.web.StatusMessage'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.ui.tree.SimpleProductStore'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.variability.EditConfigurationDialog'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.rtc.RtcSettings'); //$NON-NLS-1$
dojo.require('com.ibm.relm.ple.web.advanced.AdvancedSettings'); //$NON-NLS-1$

(function() {

var formatting = com.ibm.relm.ple.web.ui.formatting;
var html = jazz.util.html;
var Condition = com.ibm.relm.ple.web.ui.internal.views.Condition;
var TreeSelection = com.ibm.relm.ple.web.ui.TreeSelection;

var SYSTEM_PROPERTIES = com.ibm.relm.ple.web.ui.prop.UserPropertyTable.SYSTEM_PROPERTIES;
var FreezeBranch = com.ibm.relm.ple.web.ui.branch.FreezeBranch;

var _advancedSettings = com.ibm.relm.ple.web.advanced.AdvancedSettings;

var Permissions = relm.app.Permissions;

function text(str)
{
	return document.createTextNode(str);
}

function _nameValid(propertyName) {
	if (SYSTEM_PROPERTIES[propertyName]) {
		return false;
	}
	return true;
}

var AnalysisUtil = false;

jazz.core.loader.load_async('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil', function() { //$NON-NLS-1$
	// Replace the flag with the actual object once loaded.
	AnalysisUtil = dojo.getObject('dm.analysis.app.ui.internal.impactanalysis.util.AnalysisUtil'); //$NON-NLS-1$
});

dojo.declare("com.ibm.relm.ple.web.ui.internal.views.ProductView", //$NON-NLS-1$
		[ dijit._Widget, dijit._Templated ], {

	templatePath: dojo.moduleUrl("com.ibm.relm.ple.web","ui/internal/views/templates/ProductView.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,

	events: [],
	readOnly: false,

	isFrozenHierarchy: false,
	frozenTip: false,

	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.ple.web.ui.internal.views", "ProductViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.parentId = args.parentId;

		this._product = args.product;

		this._isAuditLoaded = false;
		this._resourceLinks = [];

		this.isFrozenHierarchy = FreezeBranch.checkSelectedFrozenHierarchy();
		this.frozenTip = args.product["ple:isFrozenTip"]; //$NON-NLS-1$

		this.advancedImport_enabled = !!_advancedSettings.advanced_import;
		this.variableInclusion_enabled = !!_advancedSettings.variable_include;
	},

	postMixInProperties: function() {
		this.inherited(arguments);
		this._noPropertiesMessage = this.readOnly ? this.messages.noPropertiesReadOnly : this.messages.noProperties;
	},

	hideDragWrapper: function() {
		dojo.removeClass(this._dragWrapper, 'ple-ProductView-dragWrapperVisible'); //$NON-NLS-1$
	},

	showDragWrapper: function() {
		dojo.addClass(this._dragWrapper, 'ple-ProductView-dragWrapperVisible'); //$NON-NLS-1$
	},

	_onDragStart: function(e) {
		if (!Permissions.canProductsModify()) {
			return;
		}

		if (this.readOnly) return;

		var productTree = com.ibm.relm.ple.web.ui.tree.TreeRefresh.getTree();
		if (!productTree) return;

		var draggedSite = TreeSelection.getSelectedSite();
		if (!draggedSite) return;

		var self = this;
		function avatarFactory() {
			var avatarPos = dojo.position(self._iconNode);

			// Fudge the position a bit to accommodate padding. Not really needed.
			avatarPos.x -= 4;
			avatarPos.y -= 4;

			var avatar = new com.ibm.relm.ple.web.dnd.Avatar({
				startX: avatarPos.x,
				startY: avatarPos.y
			});

			var iconNode = self._iconNode.cloneNode(true);
			dojo.removeAttr(iconNode, 'title'); //$NON-NLS-1$
			var labelNode = self._titleNode.cloneNode(true);

			dojo.place(iconNode, avatar.contentNode);
			dojo.place(labelNode, avatar.contentNode);

			return avatar;
		}

		productTree.startDrag(e, draggedSite, avatarFactory);
	},

	_initReadOnlyToolbar: function() {
		this._toolbar = new jazz.ui.Toolbar();
		this._toolbar.placeAt(this._headerNode);

		var showProductButton = new jazz.ui.toolbar.Button({
			imgClass: 'ple-icon-showInTree', //$NON-NLS-1$
			title: this.messages.showInProductTree,
			label: this.messages.showInProductTree,
			onClick: dojo.hitch(this, this.findPaths)
		});
		this._toolbar.addChild(showProductButton);

		this._toolbar.addChild(new jazz.ui.toolbar.Separator());

		var findUseButton = new jazz.ui.toolbar.Button({
			imgClass: 'ple-icon-findUse', //$NON-NLS-1$
			title: this.messages.findUse,
			onClick: dojo.hitch(com.ibm.relm.ple.web.ui.Goto, com.ibm.relm.ple.web.ui.Goto.gotoFindUse, this._product.uri)
		});
		this._toolbar.addChild(findUseButton);

		if (AnalysisUtil) {
			var analysisButton = new jazz.ui.toolbar.Button({
				imgClass: 'ple-icon-impactAnalysis', //$NON-NLS-1$
				title: this.messages.startAnalysis,
				onClick: dojo.hitch(this, this._startAnalysis)
			});
			this._toolbar.addChild(analysisButton);
		}

		this._toolbar.addChild(new jazz.ui.toolbar.Separator());

		var historyButton = new jazz.ui.toolbar.Button({
			imgClass: 'ple-icon-history', //$NON-NLS-1$
			title: this.messages.showHistory,
			onClick: dojo.hitch(com.ibm.relm.ple.web.ui.Goto, com.ibm.relm.ple.web.ui.Goto.gotoShowHistory, this._product.uri)
		});
		this._toolbar.addChild(historyButton);
	},

	_startAnalysis: function(args) {
		AnalysisUtil.createAnalysisForResource(this._product.uri);
	},

	/**
	 * Adds additional details to the product header section if the product
	 * is connected to an RTC stream or component. 
	 */
	_initRtcDetails: function() {

		if (this._rtcInfoNode) {
			dojo.destroy(this._rtcInfoNode);
			delete this._rtcInfoNode;
		}

		this._rtcInfoNode = dojo.create('div', { //$NON-NLS-1$
			className: 'ple-ProductView-rtcInfo' //$NON-NLS-1$
		});

		dojo.create('hr', null, this._rtcInfoNode); //$NON-NLS-1$
		var table = dojo.place('<table class=""><col width="0"><col width="999"></table>', this._rtcInfoNode); //$NON-NLS-1$

		/**
		 * Helper function to create a table row with two cells: a TH with the given
		 * label, and an empty TD that is returned to fill later.
		 * @param  {string} label string for the label
		 * @return {TD}       the data cell to fill.
		 */
		function createRowGetTd(label) {
			var row = dojo.create('tr', null, table); //$NON-NLS-1$
			var th = dojo.create('th', { //$NON-NLS-1$
				className: 'j-label' //$NON-NLS-1$
			}, row);

			var labelId = dijit.getUniqueId('ple-ProductView'); //$NON-NLS-1$

			dojo.create('label', { //$NON-NLS-1$
				htmlFor: labelId,
				innerHTML: label
			}, th);

			return dojo.create('td', { //$NON-NLS-1$
				id: labelId
			}, row);
		}

		if (this._product.rtcComponent) {
			 var componentTd = createRowGetTd(this.messages.rtcConnectedToComponent);
			 dojo.create('img', { //$NON-NLS-1$
				src: this._blankGif,
				className: 'ple-icon ple-icon-rtcComponent' //$NON-NLS-1$
			 }, componentTd);
			 componentTd.appendChild(document.createTextNode(this._product.rtcTitle));

			var baselineTd = createRowGetTd(this.messages.rtcBaseline);
			dojo.create('img', { //$NON-NLS-1$
				src: this._blankGif,
				className: 'ple-icon ple-icon-baseline' //$NON-NLS-1$
			}, baselineTd);
			baselineTd.appendChild(document.createTextNode(this._product.rtcBaselineName));
		}
		else if (this._product.rtcStream) {
			var streamTd = createRowGetTd(this.messages.rtcConnectedToStream);
			dojo.create('img', { //$NON-NLS-1$
				src: this._blankGif,
				className: 'ple-icon ple-icon-rtcStream' //$NON-NLS-1$
			}, streamTd);
			streamTd.appendChild(document.createTextNode(this._product.rtcTitle));
		}

		var rtcServer = this._product.rtcServer;
		var rtcServerName = this._product.rtcServerName;
		if (!rtcServer) {
			rtcServer = com.ibm.relm.ple.web.rtc.RtcSettings.rtcUrls[0];
		}

		var serverTd = createRowGetTd(this.messages.rtcConnectedToServer);
		if (serverTd) {
			dojo.create('a', { //$NON-NLS-1$
				target: '_blank', //$NON-NLS-1$
				href: rtcServer,
				innerHTML: html.escape(rtcServerName) || html.escape(rtcServer)
			}, serverTd);
		}

		if (this._product.originalRtcStream){
			var originalRtcStreamTd = createRowGetTd(this.messages.rtcOriginalStreamId);
			if (originalRtcStreamTd) {
				dojo.create('span', { //$NON-NLS-1$
					innerHTML: html.escape(this._product.originalRtcStream)
				}, originalRtcStreamTd);
			}
		}
		if (this._product.originalRtcStreamName){
			var originalRtcStreamNameTd = createRowGetTd(this.messages.rtcOriginalStreamName);
			if (originalRtcStreamNameTd) {
				dojo.create('span', { //$NON-NLS-1$
					innerHTML: html.escape(this._product.originalRtcStreamName)
				}, originalRtcStreamNameTd);
			}
		}
	
		dojo.place(this._rtcInfoNode, this._headerNode);
	},

	_initConditionSection: function() {
		try {
			if (this._conditionsSection) {
					this._conditionsSection.destroyRecursive();
					delete this._conditionsSection;
				}
		
				this._conditionsSection = new com.ibm.relm.common.web.ui.Section({
					label: this.messages.conditionsHeader,
					showHelp: false,
					canCollapse: true
				});
		
				this._conditionsSection.placeAt(this._branchSection, 'after'); //$NON-NLS-1$
		
				if (!this.readOnly) {
					var editConditionsLink = dojo.create('a', { //$NON-NLS-1$
						href: '#', //$NON-NLS-1$
						title: this.messages.editConditionsTooltip,
						innerHTML: html.escape(this.messages.editBranchDimensionsLink),
						className: 'relm-Section-link'}); //$NON-NLS-1$
					this.connect(editConditionsLink, 'onclick', this._onEditConditions); //$NON-NLS-1$
					this._conditionsSection.setControls(editConditionsLink);
				}
		}
		catch (e) {
			// FIXME: this seems to fail sometimes, but I don't know why. This is just here to debug if I see again.
			console.debug(e);
		}
	},

	_initConfigurationVariablesSection: function() {
		if (this._configSection) {
			this._configSection.destroyRecursive();
			delete this._configSection;
			delete this._configurationNode;
		}

		this._configSection = new com.ibm.relm.common.web.ui.Section({
			label: this.messages.configurationSection,
			canCollapse: true,
			showHelp: false
		});
		
		this._configurationNode = dojo.create('div', null, this._configSection.containerNode); //$NON-NLS-1$

		if (!this.readOnly) {
			var editConfigurationLink = dojo.create('a', { //$NON-NLS-1$
				href: '#', //$NON-NLS-1$
				title: this.messages.editConfigurationsTooltip,
				innerHTML: html.escape(this.messages.editBranchDimensionsLink),
				className: 'relm-Section-link' //$NON-NLS-1$
			});

			this.connect(editConfigurationLink, 'onclick', dojo.hitch(this, this._onEditConfiguration)); //$NON-NLS-1$
			this._configSection.setControls(editConfigurationLink);
		}

		this._configSection.placeAt(this._contentNode, 'first'); //$NON-NLS-1$
	},

	_onEditConfiguration: function(e) {
		dojo.stopEvent(e);
		var dialog = new com.ibm.relm.ple.web.variability.EditConfigurationDialog({
			product: this._product
		});
		dialog.startup();
	},


	_initPropertiesSection: function() {
		this._propertiesSection = new com.ibm.relm.common.web.ui.Section({
			label: this.messages.propertiesSection,
			canCollapse: true,
			uaKey: 'com.ibm.relm.common.web.page_Properties001' //$NON-NLS-1$
		});

		this._propertiesSection.placeAt(this._contentNode, 'first'); //$NON-NLS-1$

		this._propertiesTable = new jazz.ui.StyledTable({
			trim: jazz.ui.StyledTable.TrimStyles.SECONDARY_HEADLESS,
			showHover: false,
			columns: [
				{
					label: this.messages.propertyName,
					width: '50px' //$NON-NLS-1$
				},
				{
					label: this.messages.propertyValue,
					width: '9999px' //$NON-NLS-1$
				},
				{
					label: '', //$NON-NLS-1$
					width: '20px' //$NON-NLS-1$
				}

			]
		});

		this._propertiesTable.placeAt(this._propertiesSection.containerNode);

		this._noProperties = dojo.create('div', { //$NON-NLS-1$
			className: 'ple-UserPropertyTable-noProperties', //$NON-NLS-1$
			style: 'display: none', //$NON-NLS-1$
			innerHTML: html.escape(this._noPropertiesMessage)
		}, this._propertiesSection.containerNode);

		if (!this.readOnly) {
			var editPropertiesLink = dojo.create('a', { //$NON-NLS-1$
				href: '#', //$NON-NLS-1$
				title: this.messages.editPropertiesTooltip,
				innerHTML: html.escape(this.messages.editPropertiesLink),
				className: 'relm-Section-link' //$NON-NLS-1$
			});
			this.connect(editPropertiesLink, 'onclick', dojo.hitch(this, function(e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				dojo.publish('ple.edit_properties'); //$NON-NLS-1$
			}));
			this._propertiesSection.setControls(editPropertiesLink);
		}

	},

	postCreate: function() {
		this.subscribe('ple.detail_view.save', this.save); //$NON-NLS-1$
		// IE workaround
		this.subscribe('ple.product_tree.drag_did_end', this.hideDragWrapper); //$NON-NLS-1$

		dojo.attr(this._manageDimensionsLink, 'href', '#' + dojo.objectToQuery({ //$NON-NLS-1$ //$NON-NLS-2$
			action: 'ple.manage_dimensions', //$NON-NLS-1$
			product: this._product.uri
		}));

		var product = this._product;

		if (product.conditionVariables !== undefined) {
			this._initConfigurationVariablesSection();			
		}
		else {
			this._initPropertiesSection();
		}

		if (this.readOnly) {
			dojo.addClass(this.domNode, 'ple-ProductView-readonly'); //$NON-NLS-1$
			dojo.addClass(this._titleNode, 'j-h1'); //$NON-NLS-1$

			this._initReadOnlyToolbar();
			this._linksSection = new com.ibm.relm.common.web.ui.Section({
				label: this.messages.linksSection,
				canCollapse: true,
				showHelp: false
			});

			this._linksSection.placeAt(this._propertiesSection.domNode, 'after'); //$NON-NLS-1$
		}

		if (!this.readOnly) {
			if (Permissions.canProductsAddProperty() && !this.isFrozenHierarchy  && !this.frozenTip) {
				dojo.addClass(this.domNode, 'relm-products-addProperty'); //$NON-NLS-1$
			}

			if (Permissions.canProductsModify() && !this.isFrozenHierarchy && !this.frozenTip) {
				dojo.addClass(this.domNode, 'relm-products-modify'); //$NON-NLS-1$
			}
		}

		this._initFromProduct(this._product);
		this.subscribe('ple.detail_view.refresh', this._refreshFromNewProductOrCurrent); //$NON-NLS-1$

		if (!this.readOnly) {
			this._autoHeight = new com.ibm.relm.common.web.ui.AutoHeightBox(this._contentNode, {
				listenOnPage: 'com.ibm.relm.ple.web.ui.pages.ProductsPage', //$NON-NLS-1$
				fillPageWidth: false
			});

			if (Permissions.canProductsBranch()) {
				var editBranches = dojo.create('a', { //$NON-NLS-1$
					href: '#', //$NON-NLS-1$
					title: this.messages.editBranchDimensionsTooltip,
					innerHTML: html.escape(this.messages.editBranchDimensionsLink),
					className: 'relm-Section-link'}); //$NON-NLS-1$
				this.connect(editBranches, 'onclick', this._onEditDimensions); //$NON-NLS-1$
				this._branchSection.setControls(editBranches);
			}
		}

		this.connect(this._auditSection, 'onCollapse', this._loadAudit); //$NON-NLS-1$

		this.subscribe('ple.branch_was_updated', this.refresh); //$NON-NLS-1$
	},

	_onEditConditions: function(e) {
		dojo.stopEvent(e);

		var dialog = new com.ibm.relm.ple.web.variability.EditConditionsDialog({
			product: this._product
		});
		dialog.startup();
		return;
	},

	updateConfiguration: function() {
		if (!this._configurationNode) return;

		var configHtml = this._product.conditionVariablesHtml;

		dojo.empty(this._configurationNode);

		if (configHtml) {
			this._configurationNode.innerHTML = this._product.conditionVariablesHtml;
		}
		else {
			dojo.create('div', { //$NON-NLS-1$
				innerHTML: html.escape(this.messages.noConfigurationVariables),
				className: 'ple-UserPropertyTable-noProperties' //$NON-NLS-1$
			}, this._configurationNode);
		}
	},

	updateConditions: function() {
		if (!this._conditionsSection) return;

		var box = this._conditionsSection.containerNode;
		dojo.empty(box);

		if (this._product.condition) {
			box.innerHTML = html.escape(this._product.condition);
		}
		else {
			dojo.create('div', { //$NON-NLS-1$
				innerHTML: html.escape(this.messages.noConditions),
				className: 'ple-UserPropertyTable-noProperties' //$NON-NLS-1$
			}, box);
		}
	},

	findPaths: function() {
		com.ibm.relm.ple.web.ui.productapi.findPathsToProductAndShow(this._product.uri);
	},

	rename: function() {
		//Disable renaming on a frozen product or a product under a frozen hierarchy
		if (this.readOnly || !Permissions.canProductsAddProperty() || this.isFrozenHierarchy || this.frozenTip) return;

		var dialog = com.ibm.relm.ple.web.productedit.RenameProductDialog({
			itemVersion: this._product
		});
		dialog.startup();
	},

	_loadAudit: function(nowOpen) {
		this._auditMessageBox.hideMessage();

		var self = this;

		function cleanUp() {
			self._auditLoadingMessage.hide();
		}

		if (!this._isAuditLoaded) {
			var get = jazz.client.xhrGet({
				url: net.jazz.ajax._contextRoot + '/ple/audit_log', //$NON-NLS-1$
				handleAs: 'json', //$NON-NLS-1$
				content: {
					itemVersionUri: this._product.uri
				},

				error: function(_, args) {
					cleanUp();
					self._auditMessageBox.showXhrError(args.xhr);
				}
			});

			get.then(function(jsonAuditData) {
				cleanUp();
				self._productAudit && self._productAudit.destroyRecursive();

				self._productAudit = new com.ibm.relm.ple.web.ui.audit.ProductAudit({
					auditData: jsonAuditData,
					batchLoader: new com.ibm.relm.common.web.ResourceLinkBatchLoader()
				});
				self._productAudit.placeAt(self._auditLogContainer);

				self._isAuditLoaded = true;
			});

		}
	},

	_drawBranchTable: function(branchDimensions) {
		dojo.empty(this._branchDimTable);

		if (!Permissions.canProductsBranch()) {
			this._manageDimensionsLinkWrapper.style.display = 'none'; //$NON-NLS-1$
		}

		if (branchDimensions.length === 0) {
			this._manageDimensionsLinkWrapper.style.textAlign = 'center'; //$NON-NLS-1$

			dojo.create('div', { //$NON-NLS-1$
				innerHTML: this.readOnly ? this.messages.noDimensionsReadOnly : this.messages.noDimensionsInfoMessage,
				className: 'ple-UserPropertyTable-noProperties' //$NON-NLS-1$
			}, this._branchDimTable);
			return;
		}

		this._manageDimensionsLinkWrapper.style.textAlign = 'right'; //$NON-NLS-1$
		
		var columns = [
			{label: this.messages.dimensionNameColumnLabel, width: '1px', style: {textWrap: 'suppress'}}, //$NON-NLS-1$ //$NON-NLS-2$
			{label: this.messages.dimensionValueColumnLabel, width: '9999px'} //$NON-NLS-1$
		];

		this._branchTable = new jazz.ui.StyledTable({columns: columns});

		for (var i = 0; i < branchDimensions.length; i++) {
			
			var row = dojo.create('tr', null, this._branchTable.tbody); //$NON-NLS-1$
			dojo.create('td', { //$NON-NLS-1$
				innerHTML: formatting.formatDimensionIconAndTitle(branchDimensions[i]),
				style: {whiteSpace: 'nowrap'} //$NON-NLS-1$
			}, row);
			dojo.create('td', {innerHTML: html.escape(branchDimensions[i].value)}, row); //$NON-NLS-1$
		}

		this._branchTable.placeAt(this._branchDimTable);
	},

	_destroyResourceLinks: function() {
		dojo.forEach(this._resourceLinks, function(resourceLink) {
			resourceLink.destroyRecursive();
		});

		this._resourceLinks = [];
	},

	/**
	 * Only for read-only view (when not shown in the tree).
	 * Draws all the resource links the product is related to.
	 * @return {[type]} [description]
	 */
	_drawLinks: function() {
		this._destroyResourceLinks();

		dojo.forEach(this._resourceLinks, function(resourceLink) {
			resourceLink.destroyRecursive();
		});

		dojo.empty(this._linksSection.containerNode);

		var links = this._product.links;
		if (!links || !links.length) {
			var noLinksDiv = dojo.create('div', { //$NON-NLS-1$
				className: 'ple-UserPropertyTable-noProperties', //$NON-NLS-1$
				innerHTML: html.escape(this.messages.noLinks)
			});
			this._linksSection.containerNode.appendChild(noLinksDiv);
		}
		else {
			var list = dojo.create('ul', { //$NON-NLS-1$
				className: 'ple-linkList' //$NON-NLS-1$
			});

			for (var i = 0; i < links.length; i++) {
				var link = links[i];
				var listItem = dojo.create('li', null, list); //$NON-NLS-1$

				var icon = dojo.create('img', { //$NON-NLS-1$
					height: '16', //$NON-NLS-1$
					width: '16', //$NON-NLS-1$
					className: 'ple-icon', //$NON-NLS-1$
					src: dojo.moduleUrl('com.ibm.relm.ple.web','ui/images/hyperlink_co.gif') //$NON-NLS-1$ //$NON-NLS-2$
				}, listItem);

				var a = dojo.create('a', { //$NON-NLS-1$
					href: link.oslcUri,
					innerHTML: html.escape(link.name)
				}, listItem);

				var resourceLink = new jazz.ui.ResourceLink({
					iconNode: icon
				}, a);

				this._resourceLinks.push(resourceLink);
			}

			this._linksSection.containerNode.appendChild(list);
		}
	},

	isProduct: function(productVersionUri) {
		return this._product && productVersionUri == this._product.uri;
	},

	_onEditDimensions: function(e) {
		dojo.stopEvent(e);

		var product = this._product;
		var args = {
			branchName: product._branch_name,
			productName: product.name,
			productVersionUri: product.uri,
			oldBranchDimensions: product._branch_dimensions
		};

		var d = new com.ibm.relm.ple.web.ui.branch.EditBranchDialog(args);
		d.startup();
	},

	_refreshFromNewProductOrCurrent: function(newProduct) {
		if (newProduct && newProduct.type === 'product') { //$NON-NLS-1$
			this._initFromProduct(newProduct);
		}
		else {
			this.refresh();
		}
	},

	refresh: function(forceRefresh) {

		var self = this;

		jazz.client.xhrGet({
			handleAs: 'json', //$NON-NLS-1$
			url: net.jazz.ajax._contextRoot + '/ple/product_version', //$NON-NLS-1$
			content: {
				itemVersionUri: this._product.uri
			},

			load: function (product) {
				dojo.publish(jazz.ui.PageTemplate.StatusMessage.HIDE);
				self._initFromProduct(product);
			},

			error: function(error) {
				dojo.publish(jazz.ui.PageTemplate.StatusMessage.HIDE);
				console.error(error);
			}
		});

		// Auto clear the OK message after a second
		this._messageBox.hideLater();
		this.refreshAuditLog();
	},

	refreshAuditLog: function() {
		delete this._isAuditLoaded;
		dojo.empty(this._auditLogContainer);
		this._auditLoadingMessage.show();

		if (this._auditSection.isCollapsed()) {
			// will load on expand later
			return;
		}
		else {
			this._loadAudit();
		}
	},

	_drawPropertiesTable: function(product) {
		// RTC Configuration objects have no properties table.
		if (!this._propertiesSection) return;

		var userProperties = {};

		for (var anyName in product) {
			if (SYSTEM_PROPERTIES[anyName]) continue;

			userProperties[anyName] = product[anyName];
		}

		var sortedNames = [];

		for (var n in userProperties) {
			sortedNames.push(n);
		}

		// TODO: better sorting. Maybe creation order is better
		sortedNames.sort(function(left, right) {
			left = left.toLowerCase();
			right = right.toLowerCase();
			if (left < right) return -1;
			if (left > right) return 1;
			return 0;
		});

		dojo.empty(this._propertiesTable.tbody);

		var frag = document.createDocumentFragment();

		for (var i = 0; i < sortedNames.length; i++) {
			var name = sortedNames[i];
			var value = userProperties[name];

			var row = dojo.create('tr', null, frag); //$NON-NLS-1$
			var nameCell = dojo.create('td', { //$NON-NLS-1$
				className: 'j-label ple-ProductView-propertyName', //$NON-NLS-1$
				nowrap: true
			}, row);
			nameCell.appendChild(document.createTextNode(com.ibm.relm.ple.web.ui.prop.PropertyName.getReadOnlyDisplayName(name)));
			var valueCell = dojo.create('td', null, row); //$NON-NLS-1$
			valueCell.appendChild(document.createTextNode(value));
		}

		this._propertiesTable.tbody.appendChild(frag);

		this._showNoPropertiesMessage();
	},

	_showNoPropertiesMessage: function() {
		if (this._propertiesTable.tbody.rows.length === 0) {
			this._noProperties.style.display = ''; //$NON-NLS-1$
			this._propertiesTable.domNode.style.display = 'none'; //$NON-NLS-1$
		}
		else {
			this._noProperties.style.display = 'none'; //$NON-NLS-1$
			this._propertiesTable.domNode.style.display = ''; //$NON-NLS-1$
		}
	},

	_initFromProduct: function(product) {
		this._product = product;

		var forRtc = product.rtcStream || product.rtcComponent;
		if (forRtc) {
			// only show Variability Expressions for components, not streams
			if (product.rtcComponent && this.variableInclusion_enabled) {
				this._initConditionSection();
			}
			else if (this._conditionsSection) {
				this._conditionsSection.destroyRecursive();
			}
			
			this._initRtcDetails();
		}
		else {
			if (this._rtcInfoNode) {
				dojo.destroy(this._rtcInfoNode);
				delete this._rtcInfoNode;
			}
		}

		net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(product.name);

		this._titleNode.innerHTML = com.ibm.relm.ple.web.ui.formatting.formatProductTitleForItem(product);
		var classAndAltText = com.ibm.relm.ple.web.ui.formatting.getIconClassAndAltTextForItem(product);
		dojo.attr(this._iconNode, {
			className: 'ple-icon ' + classAndAltText[0], //$NON-NLS-1$
			alt: classAndAltText[1]
		});

		this._drawBranchTable(product._branch_dimensions || []);
		this._drawPropertiesTable(product);
		if (this.readOnly) {
			this._drawLinks();
		}


		this.updateConditions();
		this.updateConfiguration();

		this.refreshAuditLog();
	},

	uninitialize: function(){
		net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(''); //$NON-NLS-1$
		this._autoHeight && this._autoHeight.destroy();
		this._branchTable && this._branchTable.destroyRecursive();
		this._productAudit && this._productAudit.destroyRecursive();
		this._toolbar && this._toolbar.destroyRecursive();
		this._destroyResourceLinks();
		this._linksSection && this._linksSection.destroyRecursive();
		this._configSection && this._configSection.destroyRecursive();
		this._conditionsSection && this._conditionsSection.destroyRecursive();
		this.inherited(arguments);
	}
});

})();