/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/

(function()  {
dojo.provide("com.ibm.relm.explorer.web.ui.internal.wizard.SpecifyNameWizardStep"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$

dojo.require("jazz.ui.wizard.WizardStepHeader"); //$NON-NLS-1$
dojo.require("jazz.ui.wizard.WizardStep"); //$NON-NLS-1$
dojo.require('jazz.app.ua.TextHoverHelp'); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$
dojo.require("dojox.layout.TableContainer"); //$NON-NLS-1$
dojo.require("dojo.store.Memory"); //$NON-NLS-1$
dojo.require("dijit.form.CheckBox"); //$NON-NLS-1$

dojo.require("com.ibm.relm.explorer.web.ui.internal.view.common.ViewSelect"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.ui.internal.view.ViewClient"); //$NON-NLS-1$
dojo.require("com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "CreateNewDiagramWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.requireLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var WizardStepHeader = jazz.ui.wizard.WizardStepHeader;
var WizardStep = jazz.ui.wizard.WizardStep;
var ServiceResponseHandler = com.ibm.relm.explorer.web.explorer.page.ServiceResponseHandler;
var ViewClient = com.ibm.relm.explorer.web.ui.internal.view.ViewClient;

var BLANK_TEMPLATE = "__blank__"; //$NON-NLS-1$

dojo.declare("com.ibm.relm.explorer.web.ui.internal.wizard.SpecifyNameWizardStep",  //$NON-NLS-1$
		[WizardStep, dijit._Widget, dijit._Templated] ,{
	
	templatePath: dojo.moduleUrl("com.ibm.relm.explorer.web",  "ui/internal/wizard/templates/SpecifyNameWizardStep.html"), //$NON-NLS-1$ //$NON-NLS-2$
	widgetsInTemplate: true,
	
	permissions: {},
	
	wizard: null,
	parameterDefined: false,

	getViewUri: function(){
		return this._templateFilter.getUri();
	},
	
	postMixInProperties: function() {
		this.inherited(arguments);
		this.messages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "CreateNewDiagramWizardMessages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.viewMessages = dojo.i18n.getLocalization("com.ibm.relm.explorer.web.ui.internal", "ViewMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function() {
		this.inherited(arguments);
		
		this._hoverHelp = new jazz.app.ua.TextHoverHelp({uaKey: "com.ibm.relm.explorer.web.text_CreateViewName001", contentString: this.messages.diagramNameLabel}); //$NON-NLS-1$
		this.viewNameNode.appendChild(this._hoverHelp.domNode);
		
		
		this.header = new WizardStepHeader({stepTitle: ""}); //$NON-NLS-1$
		this.stepHeaderArea.appendChild(this.header.domNode);

		this._initFilteringSelect();
		
		this._responseCount = 0;
		this._initFolderPane();
	},
	
	destroy: function(){
		this.inherited(arguments);
		this._hoverHelp.destroy();
	},
	
	_initFilteringSelect: function() {
		this._templateFilter.searchAttr = "title"; //$NON-NLS-1$
		this._templateFilter.defaultEntry = {viewid: BLANK_TEMPLATE, uri: BLANK_TEMPLATE, title: this.messages.blankDiagram};
	},
	
	_initFolderPane: function() {
		this._allFolders = [];
		// A map mapping folder nodes to the underlying folder
		this._folderMap = {};
		
		this._createFolderTree();

		var args = {
//				ownedBy: session.getAuthenticatedContributor().itemId,
				scope: "personal" //$NON-NLS-1$
		};
		responseHandler = new ServiceResponseHandler(
				this,
				"_addFolders", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		ViewClient.getFolderDescriptors(responseHandler, args);
		args = {
				scope: "shared" //$NON-NLS-1$
		};
		responseHandler = new ServiceResponseHandler(
				this,
				"_addFolders", //$NON-NLS-1$
		"_remoteError"); //$NON-NLS-1$
		ViewClient.getFolderDescriptors(responseHandler, args);

	},

	_remoteError: function(error) {
		// Check if the content is still displaying
//		this.messageArea.showMessage("Error invoking service; message: " + error.message);
	},

	_createFolderTree: function() {
		this._folderTreeWidget = new jazz.ui.Tree();
		this._folderTree.appendChild(this._folderTreeWidget.domNode);
		this._folderTreeWidget.onSelectionChanged = dojo.hitch(this,this._handleFolderSelectionChange);

	},

	_getFoldersFromResult: function(response){

		return dojo.map(response.results.bindings, function(r){
			return { 
				"name": {  //$NON-NLS-1$
					label: r.name.value, 
					type: "uri",  //$NON-NLS-1$
					value: r.uri.value
				}, 
				"description": r.description.value, //$NON-NLS-1$
				"creator": r.creator.value, //$NON-NLS-1$
				"modified": r.modified.value,            			 //$NON-NLS-1$
				"ownedBy": r.ownedBy.value, //$NON-NLS-1$
				"shared" : (r.scope.value == "shared") ? true: false, //$NON-NLS-1$ //$NON-NLS-2$
				"parentUUID": r.parentUuid.value, //$NON-NLS-1$
				"folderUUID": r.folderUUID.value //$NON-NLS-1$
			};
		});
	},

	_addFolders: function(response) {
		var folders = this._getFoldersFromResult(response);
		this._responseCount++;
		if (!folders) folders = [];
		for (var i = 0; i < folders.length; i++) {
			this._allFolders.push(folders[i]);
		}
		if (this._responseCount == 1) {
			return;
		}
		this._addFoldersToTree();
		
	},
	
	_addFoldersToTree: function() {
		// First, find the two root folders
		var sharedRoot = null;
		var privateRoot = null;
		for (var i = 0; i < this._allFolders.length; i++) {
			var folder = this._allFolders[i];
			if (folder.parentUUID == "") { //$NON-NLS-1$
				if (folder.shared) {
					sharedRoot = folder;
				} else {
					privateRoot = folder;
				}
			}
		}

		if (privateRoot) {
			var rootItem = new jazz.ui.tree.IconItem({label: this.viewMessages.myQueries, iconClass: "iconFolder"}); //$NON-NLS-1$
			privateRoot.treeItemID = rootItem.getId();  //Save the item ID in the folders array in case we need to make tree calls based on the id
			this._folderMap[rootItem] = privateRoot;
			this._folderTreeWidget.addChild(rootItem);
			this._addChildrenForFolder(rootItem, privateRoot, this._allFolders, false, false);
		}
		if (sharedRoot) {
			var rootItem = new jazz.ui.tree.IconItem({label: this.viewMessages.sharedQueries, iconClass: "iconFolder"}); //$NON-NLS-1$
			sharedRoot.treeItemID = rootItem.getId();  //Save the item ID in the folders array in case we need to make tree calls based on the id
			this._folderMap[rootItem] = sharedRoot;
			this._folderTreeWidget.addChild(rootItem);
			this._addChildrenForFolder(rootItem, sharedRoot, this._allFolders, false, true);
			this._sharedRootItem = rootItem;
		}
	},

	/**
	 * From the list of folders, find any that are children of parentFolder, and
	 * add them to the tree. Then recurse for each of the children.
	 */
	_addChildrenForFolder: function(parentFolderNode, parentFolder, folders, parentIsRoot, parentIsShared) {
		var foldersToAdd = [];
		for (var i = 0; i < folders.length; i++) {
			// Special case where the parent is a root system folder
			if (parentIsRoot) {
				if (!folders[i].parentUUID && (folders[i].shared == parentIsShared) && (folders[i].name.label != parentFolder.name.label)) {
					foldersToAdd.push(folders[i]);
				}
			} else {
				if (folders[i].parentUUID == parentFolder.folderUUID) {
					folders[i].shared = parentFolder.shared;
					foldersToAdd.push(folders[i]);
				}
			}
		}
		foldersToAdd = foldersToAdd.sort(function(a, b) {return a.name.label > b.name.label;});
		for (var i = 0; i < foldersToAdd.length; i++) {
			var childNode = new jazz.ui.tree.IconItem({label: foldersToAdd[i].name.label, iconClass: "iconFolder"}); //$NON-NLS-1$
			foldersToAdd[i].treeItemID = childNode.getId();  //Save the item ID in the folders array in case we need to make tree calls based on the id
			this._folderMap[childNode] = foldersToAdd[i];
			parentFolderNode.addChild(childNode);
			this._addChildrenForFolder(childNode, foldersToAdd[i], folders, false, parentIsShared);
		}
	},

	_selectFolder: function(folderUUID)
	{
		if(!folderUUID){
			// fallback
			this._folderTreeWidget.setSelection(this._sharedRootItem);
			return;
		}
		//Get the itemID from the folder map based on the folder UUID
		//the select that item in the tree
		for (var key in this._folderMap)
		{
			//If the folder in the map is the same as the supplied folder UUID then get the item
			if (this._folderMap[key].folderUUID == folderUUID)
			{
				//Get the item from the tree
				var folderToSelect = this._folderTreeWidget.getItem(this._folderMap[key].treeItemID);
				//Expand the tree down to the folder to select
				var parentItem = folderToSelect.getParent();
				while (parentItem != null) 
				{
					parentItem.setExpanded(true);
					parentItem = parentItem.getParent();
				}
				//select it
				this._folderTreeWidget.setSelection(folderToSelect);
				break;
			}
		}
		
	},
	
	getSelectedFolder: function() {
		var currentFolderNode = this._folderTreeWidget.getSelection();
		var currentFolder = this._folderMap[currentFolderNode];
		if (!currentFolder || currentFolder == null) {
			return {};
		}

		return currentFolder;
	},


	_handleFolderSelectionChange: function(selection)
	{
		this.selectedFolder = this.getSelectedFolder();
		if(this.selectedFolder.shared && !this.permissions.createPermission) {
			// can not create
			alert(this.messages.noPermissionToCreateView);
		}
		this.triggerButtonStateUpdate();
	},
	
	_onDiagramNameEdit: function() {
		this.triggerButtonStateUpdate();		
	},
	
	_onSelectedChanged: function() {
		var self = this;
		self.wizard.templateId = null;
		self.parameterDefined = false;
		var viewuri = self._templateFilter.getUri(); 
		if(viewuri) {
			self.wizard.templateId = viewuri;
			if(self.wizard.templateId == BLANK_TEMPLATE) {
				self.parameterDefined = false;
				self.triggerButtonStateUpdate();
				return;
			}
			
			jazz.client.xhrGet({
				url: self.wizard.templateId + "?parameterOnly=", //$NON-NLS-1$ 
				headers: { "Accept" : "text/json"},  //$NON-NLS-1$ //$NON-NLS-2$
				handleAs: "json", //$NON-NLS-1$
				load: function(response, ioArgs){
					self.wizard.templateParams = response.params;
					// hold parameters in wizard
					if(self.wizard.templateParams && (self.wizard.templateParams.length > 0)) {
						self.parameterDefined = true;
					}
					self.triggerButtonStateUpdate();
				},
				error: function(response) {
					console.error(response.message);
				}
			});

		}

	},
	
	_onSharedCheckChanged: function() {
		
	},
	
	canFlipToNextPage: function() {
		var self = this;
		return (self._diagramName.value && 
				self.wizard.templateId && 
				(self.selectedFolder && ((self.selectedFolder.shared && self.permissions.createPermission) ||
										  !self.selectedFolder.shared )));
	},
	
	canFinish: function() {
		return false;
	},
	
	canCancel: function() {
		return true;
	}
	
	
});

}) ();