/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.relm.ple.web.ui.pages.ProductSearchProvider'); //$NON-NLS-1$

dojo.require('com.ibm.relm.ple.web.ui.searching'); //$NON-NLS-1$
dojo.require('net.jazz.ajax.ui.PlatformUI'); //$NON-NLS-1$
dojo.require('jazz.ui._SearchProvider'); //$NON-NLS-1$

(function(){

var searchutil = com.ibm.relm.ple.web.ui.searching;


dojo.declare(
	'com.ibm.relm.ple.web.ui.pages.ProductSearchProvider', //$NON-NLS-1$
	jazz.ui._SearchProvider,
{
	constructor: function() {
		this.scopes = searchutil.getProductScopes();
	},

	onUpdate: dojo.hitch(searchutil, searchutil.searchOnUpdateForBannerQuickSearch),

	onExecute: function(args) {
		window.location.href = '#' + dojo.objectToQuery({ //$NON-NLS-1$
			action: 'relm.queries.search', //$NON-NLS-1$
			q: args.query,
			scope: args.scope,
			time: new Date().getTime()
		});
	},

	postCreate: function() {
		// Check right now since we probably already missed the first _selectPage event.
		var pageId = net.jazz.ajax.ui.PlatformUI.getWorkbench().getCurrentPageId();
		this.highlightProductsIfPlePage(pageId);

		var pageList = dijit.byId('net_jazz_ajax_ui_PageList_0'); //$NON-NLS-1$
		this.connect(pageList, '_selectPage', function(page) { //$NON-NLS-1$
			this.highlightProductsIfPlePage(page.id);
		});
	},

	/**
	 * Checks the page ID to see if it's a PLE page.
	 * If so, forces the Products component menu to highlight.
	 */
	highlightProductsIfPlePage: function(pageId) {
		if (!pageId) return;
		
		// By pure convention, all the relevant PLE pages start with the same ID prefix.
		if (pageId.indexOf('com.ibm.relm.ple.') === 0 && pageId != 'com.ibm.relm.ple.web.ui.pages.MainWelcomePage') { //$NON-NLS-1$ //$NON-NLS-2$
			var pageList = dijit.byId('net_jazz_ajax_ui_PageList_0'); //$NON-NLS-1$
			dojo.forEach(pageList.domNode.getElementsByTagName("A"), function(link) { //$NON-NLS-1$
				dojo.toggleClass(link, "selected", link.__jazzPageId === 'com.ibm.relm.ple.web.ui.pages.ProductsWelcomePage'); //$NON-NLS-1$ //$NON-NLS-2$
			});
		}
	}
});

})();
